# E.R: 実行ファイル Fichero de ejecuciones # (v.2022/1/21)

#### 準備 ####

#有用な関数
#必要に応じて，次の関数を使用します。

source('S.R'); Start() #開始/初期化
Ca() #クリアオール(全部消去)＋スタート
rm(list=ls()) #全部消去 Remove all
dev.off() #デバイスを閉じる (初期値に戻る)

par(mar=c(2,2,2,2)) #余白の大きさ(下，左，上，右, 単位: mex)
load(".RData") #ワークスペースをロード
save.image(".RData") #ワークスペースを保存
getwd()    #Get working directory # 作業ディレクトリ(working directory)を確認
setwd(dir) #Set working directory # 作業ディレクトリ(working directory)を設定
# すべて折りたたみ: (Win) Alt+O       (Mac) Ctrl+Command+O
# すべて展開: 　　　(Win) Alt+Shift+O (Mac) Ctrl+Command+Shift+O
# 
# スペイン語文字・日本語(MAC)を扱うために次の関数を使用します：\
# Sys.setlocale(category = 'LC_CTYPE', locale = 'spanish')#スペイン語文字 Letras españolas\
# par(family = "HiraKakuProN-W3") #日本語(MAC) Letras japonesas\

## パッケージ##
# 次のパッケージをインストールします。(インストールは一度だけです。)

# install.packages("RColorBrewer")
# install.packages('Cairo')
# install.packages("data.table")
# install.packages("epitools")  #epitools
# install.packages("factoextra") #PCA
# install.packages("ggmosaic")
# install.packages("ggnewscale")#ggnewscale (scale_fill)
# install.packages("ggrepel") #文字列のプロットを重ねない
# install.packages("magrittr")
# install.packages("maptools")  #pointLabel
# install.packages("mosaid")    #ggnewscale
# install.packages("patchwork") #p1 + p2出力
# install.packages("textplot") ##不要？
# install.packages("vcd") #mosaic
# install.packages("wesanderson")
# install.packages('colorspace') #slanter::sheatmap
# install.packages('dendextend') #slanter::sheatmap
# install.packages('ggpubr')    #ggdensity etc.
# install.packages('ggtext')   #
# install.packages('gplots')   #
# install.packages('lattice')
# install.packages('pheatmap')
# install.packages('showtext')   #
# install.packages('slanter') #slanter::sheatmap
# install.packages('stringr')   #文字列処理
# install.packages('tidyverse') #ggplot2
# install.packages('vegan')   #

## ライブラリ##

# 次のライブラリを使用します。

library(Cairo); library(colorspace)
library(data.table); library(dendextend); library(dplyr)
library(epitools)
library(factoextra) #PCA
library(ggmosaic); library(ggnewscale); library(ggplot2); library(gplots)
library(ggrepel); library(grid); library(ggpubr); library(ggtext)
library(showtext)
library(lattice); library(latticeExtra)
library(MASS); library(magrittr); library(maptools); ibrary(mosaic)
library(patchwork); library(pheatmap)
library(RColorBrewer); library(reshape2); library(rlang)
library(scales); library(showtext); library(stringr); library(slanter)
library(textplot)##不要？
library(tidyr); library(tidyverse); library(tm)
library(viridis); library(vcd); library(vegan)
library(wordcloud)

# 有用な正規表現
# \r\n => \r\n```\r\n```{r, out.width="50%"}\r\n \
# 改行の前後に入れるコード R.script => R.markdown\

#### データの編集 ####

## 既存データ ##
# 次の既存データを使用します。
# クエスチョンマークを前につけて実行すると説明がHelp画面に表示されます。
# 実行のショートカットは[Ctrl]+[Enter]です。

?iris         #Edgar Anderson's Iris Data
?caith        #Colours of Eyes and Hair of People in Caithness
?HairEyeColor #Hair and Eye Color of Statistics Students
?mtcars       #Motor Trend Car Road Tests
?USArrests    #Violent Crime Rates by US State
?decathlon2   #Athletes' performance in decathlon
?Titanic      #Survival of passengers on the Titanic
?diamonds     #Prices of over 50,000 round cut diamonds

## データの表示 ##

Dt(iris) #Class: data.frame / Rows: 150 / Columns: 5
Dt(caith) #Class: data.frame / Rows: 4 / Columns: 5
Dt(HairEyeColor) #Class: table / Rows: 4 / Columns: 4
Dt(mtcars) #Class: data.frame / Rows: 32 / Columns: 11
Dt(USArrests) #Class: data.frame / Rows: 50 / Columns: 4
Dt(decathlon2) #Class: data.frame / Rows: 27 / Columns: 13
Dt(Titanic) #Class: table / Rows: 4 / Columns: 2
Dt(diamonds) #Class: tbl_df, tbl, data.frame / Rows: 53940 / Columns: 10

## データの入力 ##
#Ip('ファイル名[.txt]'):指定, Ip(1):選択, Ip():コピー

D=Ip('x45')         #データ例 wide
D=Ip('x45L')        #データ例 long
D=Ip('mozi')        #データ例 mozi.txt 文字データ (df)
D=Ip('js')          #データ例 js.txt 日本語/スペイン語文字データ (df)
D=Ip('s4')          #データ例 s4.txt (mt)
D=Ip('santander')   #データ例 Santander録音調査 (long)
D=Ip('santander-m') #データ例 Santander録音調査 (mt)
D=Ip('dle')         #データ例: dle.txt DLE(RAE)の見出し語 (df) 5sec

D=Ip(1)       #ファイル選択(ダイアログボックス)
D=Ip()        #コピーデータ(**コピーした後で)

## データの出力 ##
#Op():コピー, Op('ファイル名'):指定, Op(f='a.txt'), Op(E,'a.txt')

D=Ip('x45')         #簡単なデータ例 wide
E=Dat(D,r=1:3,c=2:3); Dt(E) #E:データ抽出
Op(E) #データ(E)をコピー (=> ペースト)
Op(E,'@1.txt') #ファイル指定 (=> 確認:エディタ, EXCEL, etc.)

D=Ip('js.txt') #簡単な例 (日本語/スペイン語)
Op()  #コピー => ペースト(エディタ, EXCEL, etc.)
Opj() #日本語データ.コピー => ペースト(エディタ, EXCEL, etc.)

## *データの入力 (Mac) ##
# #Ipm():コピーデータ, Ipm(1):ファイル選択, Ipm('x45.txt'):ファイル指定
# Ipm('x45.txt') #データ入力
# D=Ipm('x45.txt') #データ入力=>D
# D #表示

## データの選択 ##
Dt(E=D,r=10,c=0,n=F,rn=F,cn=F,d='')
#D:データ, r:行数,c:列数,n:行/列名表示,rn:行名表示,cn:列名表示,d:データ名など表示

D=Ip('x45.txt') #簡単な例 (行列:4x5)
Dt(r=3)     #データ表示(3行row)
Dt(c=3)     #データ表示(3列col)
Dt(r=3,c=3) #データ表示(3行,3列)
Dt(r=3,c=3,n=T) #同+(行/列名=T)
Dt(r=3,c=3,rn=T) #同+(行/列名=T)
Dt(r=3,c=3,cn=T) #同+(行/列名=T)

## スクリプト画面に表示 ##

D=Ip('x45'); Vista() #簡単なデータ例
 #
Vista(diamonds)

## データの編集 ##

D=Ip('x45'); D=edit(D); Dt() #簡単なデータ例(数値行列)
X=Edit(diamonds) #大きな行列 Matriz grande

## ファイルの編集 ##
# RStudioのソースペインの中でファイルを編集します。\

File('dle') #ファイルdle.txtをスクリプト画面で編集，保存 (Ctrl+s) ***

#### データ行列 ####

## データ行列の抽出 ##

# 行と列の抽出
#Dat(D,r,c)　(D:行列/データフレーム,r=行,c=列)

D=Ip('s4') #簡単な例: 4人の成績
Dat(r='1,3')   #行番号指定
Dat(r='i1,i3') #行頭文字指定
Dat(r='1')   #行番号指定
Dat(c='1')   #行番号指定

## 列の条件による抽出 ##

D=diamonds; Dt()        #データ例:ダイヤモンド(df)
Dat(s='ca>=0.5') # ca(rat)>=0.5のデータ行を抽出
Dat(s='v1>=0.5') # 同 Id.
Dat(s='ca>=0.5,ca<0.8') # caが[0.5,0.8]の範囲にあるデータ行を抽出
Dat(s='ca>=0.5,ca<0.8,co=E') #同+co(lor)がEであるデータ行を抽出 Id. 
Dat(s='cl#^S') # clarityがSで始まるデータ行を抽出 (#正規表現)

D=Ip('dle') #データ例: dle.txt DLE(RAE)の見出し語 (df)
E=Dat(s='Fo#a$'); Dt(E) #Fo(rma)の語尾がaであるデータ行を抽出 (#正規表現)
E=Dat(s='Fo#graf'); Dt(E) #Fo(rma)にgrafがあるデータ行を抽出 (#正規表現)
E=Dat(s='Ac=1,CV=V'); Dt(E) #Acに1,CVにVがあるデータ行を抽出 (#正規表現)

## 並べ替えとソート

#行/列の並べ替え

D=Ip('x45') #簡単な例: 行列(4x5)
Dat(r='2,1,3,4') #行並べ替え
Dat(c='2,1,3,4,5') #列並べ替え
Dat(c='B,A,C,D,E') #同
Dat(c=5:1) #列並べ替え,逆順

D=iris; Dt(cn=T) #データ: iris
D=Dat(c='5,1,2'); Dt()  #並べ替え + 抽出

#行/列のソート

#Dat([D],sr=NULL,sc=NULL,d=F)
#D:行列,sr:ソート行番号,sc:ソート列番号,d=T:降順

D=Ip('s4'); Dt() #簡単な例: 4人の成績
Dat(sc=1)    #1列昇順ソート
Dat(sc='v1') #同
Dat(sc=1,d=T)#1列降順ソート
Dat(sr=2)    #2行昇順ソート
Dat(sr='i2') #同 Id.
Dat(sr=2,d=T)#同(降順)

D=iris; Dt() #データ: iris
D=Dat(sc=1); Dt()      #1列昇順ソート
D=Dat(sc=1,d=T); Dt()  #1列降順ソート

D=Ip('dle') #DLE (RAE):見出し語(87535)，強勢位置，語末音節，語末音素
D=Dat(D,r=1:20); Dt(r=20)
S=Dat(sc=2); Dt(S,r=20)      #2列昇順ソート, キー(c=2)
S=Dat(sc=2:3); Dt(S,r=20)    #2:3列昇順ソート, キー(c=2:3)

## 左揃え/右揃え ##

D=Ip('iris'); Dt() #Dt(j=T): 左揃え
D=Ip('iris'); Dt(j=T) #Dt(j=T): 右揃え


## 小数桁数 ##
#Round(X=D,d='m=1')
#[D], d:'m-1,c1=2,r2=3' 
#(全体1桁, 1列=2桁, 2行=3桁) 

D=Ip('diamonds')
N=Dat(c='ca,p,x,y,z'); Dt(N) #数値列選択 
S=Sta(N,s='sum,min,q1,median,mean,q3,max',d=3); Dt(S)

Round(S,'m=1') #行列全体(m)の小数桁数=>1
Round(S,'r1=0') #行1(r1)の小数桁数=>1
Round(S,'c1=1,c2=3') #列1,2(c1,c2)の小数桁数=>1,3
Round(S,'m=2,r1=1,c2=1') 
#行列全体(m),行1,列2の小数桁数=>2,1,1

## クラスの変形 ##

D=diamonds; Dt() #データ: diamonds
D=Dat(c='cu,co,p'); Dt() #列選択

D=mtcars; Dt() #データ=mtcars
D=Dat(c='v,a,m'); Dt()
D=ReplaceCol(D,'vs','0=>V-shaped,1=>Straight'); Dt() #'vs'列置換
D=ReplaceCol(D,'am','0=>Automatic,1=>Manual') ; Dt() #'am'列置換

D=Titanic; Dt() #データ:Titanic
E=T2D(); Dt(E) #table => df
E=T2E(); Dt(E) #table => df(expand)

#### 記述統計 ####

#統計量: Sta(X=D,r=F,s='sum,mean,sd',d=1)
##([D],r=[F]:列/T:行,s:統計値 ex.'sum,mean,sd',d:小数桁)
#s: sum,mean,median,mid,min,max,sd,sdp,var,varp,q1,q2,q3,rng,gini,entropy
#s: gm,gmz,gsd,gsdz,kurt,kurt.r,ldi,pareto,skew,skew.e,skew.r,

D=Ip('x45')         #簡単なデータ例 x45.txt (mt)
S=Sta(s='count,sum'); Dt(S,j=T)     #個数, 和：列
S=Sta(s='count,sum',r=T); Dt(S) #個数, 和：行(r=T)

?iris; D=iris; Dt() #データ例:アヤメのがくと花弁 (df)
D=Dat(c=1:4); Dt() #数値列選択
S=Sta(s='min,q1,median,mean,q3,max',d=3); Dt(S)
summary(D) #参考: 比較

?diamonds; D=diamonds; Dt()        #データ例:ダイヤモンド(df)
D=Dat(c='ca,p,x,y,z'); Dt() #数値列選択
S=Sta(s='min,q1,median,mean,q3,max',d=3); Dt(S)
summary(D) #参考: 比較

?USArrests; D=USArrests; Dt()      #データ例:米国の暴力犯罪率(df)
D=Dat(c='1,2,4')
S=Sta(); Dt(S)
summary(D)

#クロス集計
#Cross(df=D,x=0,v=0,n=0,d=0,m=F,t=F){
#([df], x:個体列(単複), v:変数列(単複),n:数値列(単),t:入力列名付加)

D=Ip('mozi.txt') #簡単なデータ例　文字行列 (df)
Cross(x=0,v=1:3) #ダミー行列(x=0), 列(v)=1:3

D=Ip('santander.txt') #Santander (España) 録音調査:多次元文字データ
Cross(D,x=1)             #個体x=1列)
Cross(D,x=1,v=2)         #個体x=1列, 変数v=2列
Cross(D,x=1,v=3)         #個体x=1列, 変数v=3列
Cross(D,x=1,v=4)         #個体x=1列, 変数v=4列
Cross(D,x=1,v=2:4)       #個体x=1列, 変数v=2:4列
Cross(D,x='F',v='S,E,N') #同: 変数4列を頭文字で指定
Cross(D,x=1:2,v=3:4)     #個体x=1:2列, 変数v=3:4列
Cross(D,x=2:1,v=3:4)     #個体x=2:1列 順番を変える

D=HairEyeColor; Dt() #イギリス人の髪と目の色
Cross(D,x=0,v=1:3,n=4)     #ピボット (個体x=0:行名, 変数v=1:3列, n=4列合計)
Cross(D,x=0,v=1:3,n=4,t=T) #ピボット (個体x=0:行名, 変数v=1:3列, n=4列合計,t=T:入力列名付加)

?mtcars; D=mtcars; Dt() #データ例(3):自動車(データフレーム) ...
D=Dat(c='v,a,m'); Dt() #列選択
D=ReplaceCol(D,'vs','0=>V-shaped,1=>Straight'); Dt(D) #vs列置換
D=ReplaceCol(D,'am','0=>Automatic,1=>Manual') ; Dt(D) #am列置換
Cross(D,x=1,v=2) #個数
Cross(D,x=1,v=2,n=3) #和
Cross(D,x=1,v=2,n=3,m=T) #m=T平均
Cross(D,x=1,v=2,n=3,m=T,d=1) #d=1小数1桁

?Titanic; D=Titanic; Dt() #データ例(2):タイタニック(テーブル)
Cross(x=1,v=4,n=5) #クロス集計(1:Class,4:Survived)
Cross(x='C','S'=4,n='F') #同 (頭文字指定)

#### 得点 ####

## 相対得点
D=Ip('x45')         #簡単なデータ例 x45.txt (mt)
RS() #相対得点
RS(s=2) #s=2:列
RS(s=2,d=4) #s=2:列,d:小数桁=3

## 限定得点
LS()
L=LS(); Digit(L,d=3) #Digit: 小数桁を揃える
LS(s=2) #s=2:列

## 標準得点
SS()
SS(s=2) #s=2:列

## 比較得点
#CS(X=D,f=mean,s=1,d=3)
#(f=mean,median,mid,max,min; s=1:行； 2:列, d:小数桁)

Sta(r=T,s='mean')
D
CS()
Sta(r=T,s='median')
CS(f=median)

## 順位得点
RankS() 
RankS(s=2) #s=2:列
RankS(d=T) #d:降順
RankS(s=2,d=T) #s=2:列, d:降順

## 期待値，期待値差，期待値差比

Exp() #期待値
D-Exp() #期待値差
D/Exp() #期待値比
(D-Exp())/Exp() #期待値差比

## 確率頻度得点

PS()
PS(s=2) #s=2:列

#### 関係 ####

## 相関行列

#COR=function(X,sel=1) sel=0:相関行列; 1:共分散行列

#COR(X=D,s=0)
#s=0:相関行列; 1:共分散行列

D=Ip('x45') #簡単なデータ例 x45.txt
COR(s=0) #相関係数行列
COR(s=1) #共分散行列

## 連関行列 (Association matrix)
#AM(M=D,s='a')
# s='s': (A+D)/(A+B+C+D)#Simple

D=Ip('q54') #簡単なデータ例 q54.txt
AM(s='a') # 共起回数
AM(s='s') # (A+D)/(A+B+C+D)#Simple
AM(s='j') # A/(A+B+C)#Jaccard
AM(s='d') # 2*A/(2*A+B+C)#Dice
AM(s='h') # ((A+D)-(B+C))/((A+D)+(B+C))#Hamann
AM(s='y') # (A*D-B*C)/(A*D+B*C)#Yule
AM(s='p') # (A*D-B*C)/((A+B)*(C+D)*(A+C)*(B+D))^(1/2)#Phi
AM(s='o') # A/((A+B)*(A+C))^(1/2)#Ochiai
AM(s='u') # (2*A-B-C)/(2*A+B+C)#Ueda
AM(s='mi')  # log2(A*(A+B+C+D)/((A+B)*(A+C)))#相互情報量
AM(s='rmi') # log(A*(A+B+C+D)/((A+B)*(A+C)))/log((A+D)/A)#相対相互情報量

## 距離行列
#DM(X=D, d='e', s=F)
#d='e':ユークリッド距離/'m':平均距離/'r':相対距離, s:標準化

D=Ip('x45') #簡単なデータ例 x45.txt
DM() #ユークリッド距離
DM(s=T) #ユークリッド距離+標準化
DM(d='m') #平均距離
DM(d='m',s=T) #平均距離+標準化
DM(d='r') #相対距離
DM(d='r',s=T) #相対距離+標準化

D=t(D); D #転置行列
DM() #ユークリッド距離
DM(s=T) #ユークリッド距離+標準化
DM(d='m') #平均距離
DM(d='m',s=T) #平均距離+標準化
DM(d='r') #相対距離
DM(d='r',s=T) #相対距離+標準化

#### クラスター分析 ####

## 距離行列 
#Dm(M=D,md='e',s=F,t=F,d=3)
#M:数値行列,s:正規化,t:転置,d:小数桁
#md:距離の種類('[c]anberra','[e]uclidean'[def.],'[max]imum','[man]hattan','[mi]nkowski')

D=Ip('s4.txt'); Dt() #簡単な例：4人の成績 
Dm() #距離行列 

D=USArrests[,-3]; Dt(D,10) #データ:USArrests (-col.3: UrbanPop) 
D1=Dm(d=1); Dt(D1,6,6) #距離行列 (d:小数桁=1) 
D2=Dm(s=T, d=3); Dt(D2,6,6) #同 +(s:正規化(列)=T, d:小数桁=3) 

##クラスター樹形図 
#gClusterDd(M=D,md='e',mc='w',s=F,t=F,g=0,lx='',ly='',v=F,f=12,m=10,w=F)
#M:数値行列,s:正規化(列),t:転置,g:グループ数,lx,ly:ラベル,v:X軸縦,f:文字サイズ,m:マージン幅,w:白黒
#md:距離計測法('[c]anberra','[e]uclidean','[max]imum','[man]hattan','[mi]nkowski')
#mc:クラスタリング方法('[a]verage','[s]ingle','[c]omplete','[w]ard.D2')

D=Ip('s4.txt'); Dt() #簡単な例：4人の成績 
Dt(Dm(),5,5) #距離行列 
gClusterDd() #クラスター樹形図 
gClusterDd(g=2) #g:グループ数=2 
gClusterDd(g=2,lx='Persona',ly='Distancia') #lx,ly:ラベル 
gClusterDd(g=2,lx='Persona',ly='Distancia',m=5) #m:マージン=5 

D=USArrests[,-3]; Dt(D,10) #データ:USArrests (-col.3: UrbanPop) 
NS(D,2) #データを正規化(2:列/std) 表示 
Dx=Dm(s=T,d=3); Dt(Dx,6,6) #距離行列(s:正規化=T,d:小数桁=3) 
gClusterDd(s=T,lx='States',ly='Distance') #s:正規化=T,lx,ly:ラベル 
gClusterDd(s=T,lx='States',ly='Distance',f=8) #+f:文字サイズ=8 
gClusterDd(s=T,lx='States',ly='Distance',f=8,m=5) #+m:マージン=5 
gClusterDd(s=T,lx='States',ly='Distance',f=8,m=5,v=T) #+v:縦X軸=T 
gClusterDd(s=T,lx='States',ly='Distance',f=8,m=5,v=T,w=T) #+w:白黒=T 
gClusterDd(s=T,lx='States',ly='Distance',f=8,m=5,g=3) #g:グループ=3 
gClusterDd(s=T,lx='States',ly='Distance',f=8,m=5,md='c',g=3) #md:距離計測法=[c]anberra
gClusterDd(s=T,lx='States',ly='Distance',f=8,m=5,md='e',g=3) #md:距離計測法=[e]uclidean(defaut
gClusterDd(s=T,lx='States',ly='Distance',f=8,m=5,md='max',g=3) #md:距離計測法=[max]imum)
gClusterDd(s=T,lx='States',ly='Distance',f=8,m=5,md='man',g=3) #md:距離計測法=[man]hattan
gClusterDd(s=T,lx='States',ly='Distance',f=8,m=5,md='min',g=3) #md:距離計測法=[mi]nkowski
gClusterDd(s=T,lx='States',ly='Distance',f=8,m=5,mc='a',g=3) #mc:クラスタリング方法=[a]verage
gClusterDd(s=T,lx='States',ly='Distance',f=8,m=5,mc='s',g=3) #mc:クラスタリング方法=[s]ingle
gClusterDd(s=T,lx='States',ly='Distance',f=8,m=5,mc='c',g=3) #mc:クラスタリング方法=[c]omplete
gClusterDd(s=T,lx='States',ly='Distance',f=8,m=5,mc='w',g=3) #mc:クラスタリング方法=[w]ard.D2*(defaut)

#文字行列 

D=Ip('santander') #データ:santander.txt 
D=L2M(); Dt() ##文字行列=>数値行列 
D=round(RS()*100,0); Dt(); gChart() #行を相対化(パーセント) 
Dt(Dm(),6,6) #距離行列 
gClusterDd() #クラスター樹形図 
gClusterDd(g=3) #g:グループ数=2 

## クラスター・ヒートチャート 

#gHeatDd(M=D,md='e',mc='w',d=F,r=4,c=4,s=F,gr=2,gc=2,lx='',ly='',l=F,v=F,f=12,k=F,t=F,w=F,dn=0)
#M:数値行列=D,md(*),mc(*),d:対角化,r:樹形図の高さ(行)(0:なし),c:樹形図の高さ(行)(0:なし)
#s:正規化(列),gr:行グループ数=2,gc:列グループ数=2
#lx,ly:ラベル,l:凡例表示,v;縦X軸ラベル,f:フォントサイズ,k:数値表示,t:行列転置,w:白黒,dn:小数桁
#md(*):距離計測方法('[c]anberra','[e]uclidean','[max]imum','[man]hattan','[mi]nkowski')
#mc(*):クラスタリング方法('[a]verage','[s]ingle','[c]omplete','[w]ard.D2')

D=Ip('s4.txt'); Dt() #簡単な例: 4人の成績 
gHeatDd() #クラスター・ヒートチャート 
gHeatDd(gr=3,gc=0) #gr:行分割=3,gc:列分割=0 
gHeatDd(r=2,c=0) #樹形図の高さ(行)=2,(列)=0(無表示) 
gHeatDd(lx='Subject',ly='Person',v=T) #ラベル(x,y), v:縦X軸ラベル=T 
gHeatDd(f=15) #f:フォントサイズ=15 
gHeatDd(k=T) #k:数値出力=T 
gHeatDd(k=T,l=T) #l:凡例出力=T 
gHeatDd(t=T) #行列転置 
gHeatDd(w=T) #白黒 

D=Ip('santander-m'); Dt() #データ: santander-m 
gHeatDd() #クラスター・ヒートチャート 
gHeatDd(E,f=10,k=T) #+f:フォントサイズ=10, k:数値表示=T 
gHeatDd(D,f=10,k=T,gr=3, gc=2) #+gr:行グループ数=3, gr:列グループ数=2 

#### 主成分分析 ####
## 固有値
#PcaEv(M=D,s=T) #s=T: 標準化(単位が異なるとき)
D=Ip('s4.txt') #簡単な例：4人の成績
PcaEv() #主成分分析:固有値(分散),分散%,分散累積%
PcaEv(s=F) #s=F: 標準化しない(単位が同じ)

## バイプロット

#gPcaBp(M=D,lx='',ly='',s=0,c='',a=T,w=F,f=12,m=1)
#M:数値行列,lx,ly:ラベル,s=[0]:変数+個体/s=1:変数/s=2:個体,
#c:色指定(例:'V=>blue,..'),a:矢印,w:白黒,f:フォントサイズ,m:変数Vの乗数
#色彩:http://www.sthda.com/english/wiki/colors-in-r
#[b]lue(#039), [c]harcoal(#c30), [o]range(#f60), [p]urple(#coc), [r]ed (#f30)

D=Ip('s4.txt') #簡単な例：4人の成績
gPcaBp() #主成分分析バイプロット
gPcaBp(s=1) #s=1:変数プロット
gPcaBp(s=2) #s=2:個体プロット
gPcaBp(c='V=>#f60,V:v2=>orange,I:i3=>red') #c:色指定
gPcaBp(c='V=>b',a=F) #a:矢印=F
gPcaBp(c='V=>r',st=T) #st:標準化=T
gPcaBp(c='V=>p',f=12) #f:フォントサイズ=10
gPcaBp(lx='1 軸 (65.2%)',ly='2 軸 (31.6%)',w=T) #w=T:白黒
gChart(a=90)+gPcaBp()#比較:頻度分布+主成分分析バイプロット

D=USArrests; Dt() #米国の暴力犯罪率
PcaEv() #主成分分析:固有値(分散),分散%,分散累積%
gPcaBp(c='V=>blue') #c:軸ラベルの色=blue
gPcaBp(c='V=>blue',m=1.8,f=10) #同+m:変数Vの乗数=1.8,f:フォントサイズ=10

D=decathlon2; Dt(n=T) #十種競技(+Rank,Points,Competition)
D=D[1:15,1:10]; Dt() #D:十種競技(15名,-Rank,Points,Competition)
PcaEv() #主成分分析:固有値(分散),分散%,分散累積%
gPcaBp() #主成分分析バイプロット
gPcaBp(c='V=>b') #軸ラベル
gPcaBp(c='V=>b',m=3.5) #軸ラベル 拡大([m]ultiply=3.5)
Grp=decathlon2[1:15,13]; G #グループ:Competition
gPcaGp(D,Grp,lg='Grupo') #主成分分析(グループ)
gPcaGp(D,Grp,lg='Grupo',c='forestgreen,red') #主成分分析(グループ)

#### 対応分析 ####

## 固有値
D=Ip('s4.txt') #簡単な例: 4人の成績
Ev=CorrespEv(); Ev #対応分析: E:固有値；R:相関係数; P:寄与率；C:累積寄与率

## 対角化
D=Ip('s4'); gChart() #簡単な例
D0=CorrespDg(d=0); Dt(D0); gChart(D0) #対応分析:対角化(なし)
D1=CorrespDg(d=1); Dt(D1); gChart(D1) #対応分析:対角化(行)
D2=CorrespDg(d=2); Dt(D2); gChart(D2) #対応分析:対角化(列)
D3=CorrespDg(d=3); Dt(D3); gChart(D3) #対応分析:対角化(行/列)

## 対角化ヒートチャート
D=Ip('s4'); gChart() #簡単な例
gChart(d=1) #対角化(行)
gChart(d=2) #対角化(列)
gChart(d=3) #対角化(行/列)

## スコア
CorrespSc(s=0) #行スコア
CorrespSc(s=1) #列スコア

## バイプロット
#gCorrespBp(M=D,lx='',ly='',s=0,c='',a=T,w=F,f=12,m=1)
#M:数値行列,lx,ly:ラベル,s=[0]:変数+個体/s=1:変数/s=2:個体,
#c:色指定(例:'V=>blue,..'),a:矢印,w:白黒,m:変数Vの乗数

D=Ip('s4.txt'); Dt() #簡単な例: 4人の成績
gCorrespBp()          #対応分析:バイプロット: 固有値*相関係数(X-Y軸)
gCorrespBp(c='V=>r')  #V文字色指定
gCorrespBp(c='V=>b,I=>c')   #V,I文字色指定
gCorrespBp(c='V=>b',m=.7)   #m:変数Vの乗数=.7
gCorrespBp(c='V=>b',m=.7,a=F) #a=F:矢印なし
gCorrespBp(w=T)               #w=T: 白黒
gChart(a=90,f=10)+gCorrespBp(c='V=>b')  #行列とバイプロットを比較

## 単純対応分析: 数値行列

D=caith; Dt() #データ：caith (data.frame)
gChart(lx='Hair',ly='Eye',lg='Frequency')
CorrespEv() # E:固有値；R:相関係数; P:寄与率；C:累積寄与率
Dg=CorrespDg(d=3); Dt(Dg); gChart(Dg)          #対応分析:対角化
gChart(D,a=90)+gChart(Dg,a=90)           #対角化なし+対角化あり
gChart(lx='Hair',ly='Eye',lg='Frequency',a=90,b=20)
gCorrespBp() #バイプロット: 固有値*相関係数(X-Y軸)
gCorrespBp(c='V=>r') #V文字色指定
gCorrespBp(c='V=>b,I=>g') #V,I文字色指定
gCorrespBp(c='V=>blue',a=F) #文字色指定; a=F:矢印なし
gCorrespBp(w=T) #w=T: 白黒

## 多重対応分析: 文字行列.<2>次元 

D=Ip('mozi.txt') #簡単なデータ例　文字行列 (df)
D=Cross(v=1:3); Dt() #ダミー行列
CorrespEv() #E:固有値；R:相関係数; P:寄与率；C:累積寄与率
E=CorrespDg(); E; gChart(E) #分布の対角化
gChart(D,a=90)+gChart(E,a=90) #
gChart(D,a=90,b=10)+gChart(E,a=90,b=10)
gCorrespBp(s=1) #バイプロット(X-Y軸=固有値*相関係数), s=1:変数出力
gCorrespBp(s=1,c='V:a=>r,V:b=>g,V:c=>b') #色指定
gCorrespBp(s=1,c='V:a=>r,V:b=>g,V:c=>b',a=F) #同+a=F:矢印なしF

## 多重対応分析: 文字行列.<3>次元

D=HairEyeColor; Dt() #Hair,Eye,Sex: tb(table)
D=Cross(v=1:3,n=4,t=T); Dt() #数値行列
gChart(lx='Hair',ly='Eye',lg='Frequency',a=90,f=8) #a:X軸ラベル角度=90, f:フォントサイズ=8
gChart(lx='Hair',ly='Eye',lg='Frequency',a=90,f=8,d=3) #同+d=3:対角化:行/列
gCorrespBp(s=1) #バイプロット(X-Y軸=固有値*相関係数), s=1:変数出力
gCorrespBp(s=1,c='V:H=>r,V:E=>g,V:S=>b') #同+色指定
gCorrespBp(s=1,c='V:H=>r,V:E=>g,V:S=>b',a=F) #同+a=F:矢印なしF

## チャート

# gChart(f=20,E=D,s=0,lm='',lx='',ly='',lg='',X='',Y='',a=0,b=15,f=12,k=T,t=F,w=F,d=0,c=F,gx=0,gy=0,ar=F,ac=F)\
# D:数値行列,s:チャート選択=0/'h':ヒートチャート,
# s=1/'b':バブルチャート, s=2/'bf':バブルフィルチャート,
# s=3/'s':スクエアチャート, s=4/'sf':スクエアフィルチャート,
# lm,lx,ly,lg:ラベル,X,Y:並べ替え,a:X軸ラベル角度,b:バブルサイズ,f:フォントサイズ,
# k:数値表示,t:転置,w:白黒,d:対角化=0:なし,1:行,2:列,3:行列,c:連続軸,gx.gy:グループ数(x軸,y軸),
# ar:行軸間隔調整(d>0,c=T),ac:列軸間隔調整(d>0,c=T)\

D=Ip('santander-m') #データ:santander-m
CorrespEv() #E:固有値；R:相関係数; P:寄与率；C:累積寄与率
gCorrespBp(s=1) #バイプロット: 固有値*相関係数(X-Y軸), s=1:変数のみ出力
gCorrespBp(s=1,c='V:H=>r,V:E=>g,V:S=>b') #列(細分)と行の文字色指定
gChart()                         #(デフォルト)
gChart(gx=2,gy=3,lg='Frec.',d=1) #gx, gy:クラスターグループ=2,3, lg:凡例,d=1:対角化=行
gChart(gx=2,gy=3,lg='Frec.',d=2) #gx, gy:クラスターグループ=2,3, lg:凡例,d=1:対角化=列
gChart(gx=2,gy=3,lg='Frec.',d=3) #gx, gy:クラスターグループ=2,3, lg:凡例,d=1:対角化=行/列
E=CorrespDg(); E #分布の対角化
gChart(D,a=90,f=8) + gChart(E,a=90,f=8)
gChart(D,d=3,s=1,b=10) #d=3:行/列の対角化, s=1:バブルチャート, b:バブルの大きさ=10
gChart(D,d=3,s=1,b=10,c=T)                         #同+c=T:連続値
gChart(D,d=3,s=1,b=10,c=T,ar=T,ac=T,m=8)           #同+ar,ac:行/列軸調整=T,m:左マージン=8
gChart(D,d=3,s=1,b=10,c=T,ar=T,ac=T,m=8,gx=3,gy=3) #同+gx,gy:行/列グループ=3

#### 変異 ####

## 棒グラフ
#gBar(d=D,x=0,y=0,n=0,p='d',lm='',lx='',ly='',lg='',X='',Y='',a=0,f=12,c=1,l=F,z=F,k=T,v=F,t=F){
#(d:データ,x,y,n:軸,p:配置([d]odge,[s]tack,[f]ill),lm,lx,ly,lg:ラベル,X,Y:並べ替え
#a:ラベル角度,f:フォントサイズ,c:パレット番号,l:対数軸,z:軸ゼロ開始,k:数値,v:縦図,t:転置

D=Ip('x45.txt') #簡単な数値行列(4x5)
gBar() #棒グラフ
gBar(p='s') #ポジション: [s]tack
gBar(p='f',k=T,v=T) #ポジション: [f]ill
gBar(lx='地域',ly='パーセント',lg='単語') #ラベル
gBar(X='w2,w1,w3,w4',Y='B,A,C,D,E') #並べ替え
gBar(a=90) #X軸を90度回転
gBar(f=15) #f:フォントサイズ
gBar(c=0) #色パレット 0 (白黒)
gBar(c=1) #色パレット 1 (デフォルト)
gBar(c=2) #色パレット 2
gBar(c=3) #色パレット 3
gBar(c=10) #色パレット10
gBar(c='tomato,green,#a19df1,grey,black') #色: 指定
gBar(l=T) #l:対数軸
gBar(k=F) #k:数値なし
gBar(v=T) #v:縦図
gBar(k=T,v=T) #k:数値; v:縦図
gBar()+gBar(t=T) #t:転置

D=Ip('x45L'); Dt() # 簡単なロングフォーム
gBar(x=1,y=2,n=3)  # ロングフォームの場合x, y,n を指定

## ファセット棒グラフ
#gBarFacet(d=D,x=0,y=0,n=0,lx='',ly='',X='',Y='',a=0,e=F,f=12,c=1,l=F,z=F,k=F,v=F,t=F)
#(d:データ,x,y,n:軸,lx,ly:ラベル,X,Y:並べ替え
#a:ラベル角度,e:縦ファセット,f:フォントサイズ,c:パレット番号,l:対数軸,z:軸ゼロ開始,k:数値,v:縦図,t:転置

D=Ip('x45') #簡単な例(数値行列:4x5)
gBarFacet()  #データ読み込み 
gBarFacet(k=T,v=T) #ポジション: [f]ill
gBarFacet(lm='Faceta\n',lx='Estilo',ly='Palabra') #ラベル
gBarFacet(X='w2,w1,w3,w4',Y='B,A,C,D,E') #並べ替え
gBarFacet(a=90) #a:ラベル角度
gBarFacet(e=T) #e:縦ファセット
gBarFacet(f=15) #f:フォントサイズ
gBarFacet(c=0) #色パレット 0 (白黒)
gBarFacet(c=1) #色パレット 1 (デフォルト)
gBarFacet(c=2) #色パレット 2
gBarFacet(c='tomato,green,#a19df1,grey,black') #色: 指定
gBarFacet(l=T) #l:対数軸
gBarFacet(k=F) #k:数値なし
gBarFacet(k=T,v=T) #k:数値; v:縦図
G=gBarFacet()+gBarFacet(t=T); G #t:転置

D=Ip('x45L'); Dt() # ロング形式
gBarFacet(x=1,y=2,n=3,k=T) #x,y,nを指定
gBarFacet(x=1,y=2,n=3,k=T)+gBarFacet(x=1,y=2,n=3,k=T,t=T) #t:転置

## 線グラフ Gráfico de líneas ##
#gLine(d=D,x=0,y=0,n=0,lm='',lx='',ly='',lg='',X='',Y='',a=0,f=12,c=1,l=F,z=F,k=F,v=F,t=F,u=0)
#(d:データ,x,y,n:軸,lm,lx,ly,lg:ラベル,X,Y:並べ替え
#a:ラベル角度,f:フォントサイズ,c:パレット番号,l:対数軸,z:軸ゼロ開始,k:数値,v:縦図,t:転置
#,u:線結合ラベル(0:なし,1:左,2:右,3:左右)

D=Ip('x45.txt') #簡単な例(数値行列:4x5)
gLine(k=T) #数値
gLine(lx='単語',ly='頻度',lg='地域') #ラベル
gLine(X='w2,w1,w3,w4',Y='B,A,C,D,E') #並べ替え
gLine(a=90) #a=90:ラベル角度
gLine(f=15) #f=15:フォントサイズ
gLine(c=0) #色パレット 0(白黒)
gLine(c=1) #色パレット 1(デフォルト)
gLine(c=2) #色パレット 2
gLine(c='tomato,green,#a19df1,grey,black') #色: 指定
gLine(l=T) #l:対数軸
gLine(k=T) #k:数値
gLine(v=T) #v:縦図
gLine(u=1) #u=1:レベル結合線(左)
gLine(u=2) #u=2:レベル結合線(右)
gLine(u=3) #u=3:レベル結合線(左右)
gLine()+gLine(t=T) #t:転置
gLine(k=T,v=T,lx='Palabra',lg='Zona') #k:数値; v:縦図

D=Ip('x45L') # ロングフォーム
gLine(x=1,y=2,n=3)+gLine(x=1,y=2,n=3,k=T,t=T) #t:転置

D=caith; Dt() #データ例(1):イギリス人の目と髪の色(データフレーム)
gLine() #数値行列

## 面グラフ Gráfico de áreas ####
#gArea(d=D,x=0,y=0,n=0,p='s',lm='',lx='',ly='',lg='',X='',Y='',a=0,f=12,c=1,l=F,z=F,k=F,v=F,t=F)
#d:データ,x,y,n:軸,p:配置([d]odge,[s]tack,[f]ill),lm,lx,ly,lg:ラベル,X,Y:並べ替え
#a:ラベル角度,f:フォントサイズ,c:パレット番号,l:対数軸,z:軸ゼロ開始,k:数値,v:縦図,t:転置

D=Ip('x45') #簡単な例(数値行列:4x5)
gArea(p='s') #ポジション: [s]tack
gArea(p='f',k=T,v=T) #ポジション: [f]ill
gArea(p='f',lx='単語',ly='パーセント',lg='地域')
gArea(X='w2,w1,w3,w4',Y='B,A,C,D,E') #X,Y軸並べ替え
gArea(a=90) #a:ラベル角度=90
gArea(f=15) #f:フォントサイズ=15
gArea(c=0) #色パレット 0 (白黒)
gArea(c=1) #色パレット 1 (デフォルト)
gArea(c=2) #色パレット 2
gArea(c=3) #色パレット 3
gArea(c=10) #色パレット10
gArea(c='tomato,green,#a19df1,grey,black') #色: 指定
gArea(l=T) #l:対数軸
gArea(k=F) #k:数値なし
gArea(v=T) #v:縦図
gArea(k=T,v=T) #k:数値; v:縦図
gArea()+gArea(t=T) #t:転置

D=Ip('x45L')
gArea(x=1,y=2,n=3) # ロングフォーム

## ヒストグラフ Histografía ##
#gHist(df=D,x=1,g=0,p='d',lx='',ly='',b=10,f=10,c=1,z=F,k=F,v=F) 
#df,x:x軸列,g:グループ列,p:[d]odge,[s]tack,[f]ill),lx,ly:ラベル(x,y),c:カラーパレット
#b:棒数,z:0を含むx軸,f:フォントサイズ,k:数値出力,v:縦図

D=iris; Dt() #アヤメ(データフレーム)
gHist()#データ=iris,x軸=1列('Sepallength')
gHist(c=0)#c=0:白黒
gHist(c=2)#c=1~10:カラー
gHist(x=1,g=5)#g:グループ=5列
gHist(x=1,g=5,c=0)#g:グループ=5列,色パレット:0 (白黒)
gHist(x=1,g=5,c=1)#g:グループ=5列,色パレット:1 (デフォルト)
gHist(x=1,g=5,c=2)#g:グループ=5列,色パレット:2
gHist(x=1,g=5,p='s')#p:配置=Stack
gHist(x=1,g=5,p='f')#p:配置=Fill
gHist(x=1,g=5,p='f',k=T)#Fill; k=T:数値
gHist(x=1,g=5,lx='Sepal length',ly='Count',lg='Species')#lx,ly:ラベル(x,y)
gHist(x=1,g=5,f=15)#f:フォント=15
gHist(x=1,g=5,z=T)#z:ゼロを含む軸=T
gHist(x=1,g=5,k=T)#k:数値=T
gHist(x=1,g=5,k=T,v=T)#同+v:縦

####チャート ####
#gChart(E=D,s=0,lm='',lx='',ly='',lg='',X='',Y='',a=0,b=15,f=12,k=T,t=F,w=F,
#d=0,c=F,gx=0,gy=0,ar=F,ac=F)
#[D]:数値行列,s:チャート選択=0/'h':ヒートチャート
#s=1/'b':バブルチャート, s=2/'bf':バブルフィルチャート,s=3/'s':スクエアチャート: s=4/'sf':スクエアフィルチャート:
#lm,lx,ly,lg:ラベル,X,Y:並べ替え,a:X軸ラベル角度(T=90),b:バブルサイズ,f:フォントサイズ,
#k:数値表示,t:転置,w:白黒,d:対角化=0:なし,1:行,2:列,3:行列,c:連続軸,gx.gy:グループ数(x軸,y軸),
#ar:行軸間隔調整(d>0,c=T),ac:列軸間隔調整(d>0,c=T)

## ヒートチャート

D=Ip('x45') #簡単な例(数値行列:4x5)
gChart() #チャート(デフォルト,s=0:ヒートチャート)
gChart(f=20) #f:フォントサイズ
gChart(lx='地域',ly='単語')           #ラベル
gChart(lx='地域',ly='単語',lg='頻度') #ラベル,lg:凡例
gChart(X='w2,w1,w3,w4',Y='B,A,C,D,E') #ラベル順
gChart(a=90) #a:ラベル角度
gChart(w=T) #w:白黒
gChart(k=F) #数値なし(k=T:デフォルト)
gChart()+gChart(t=T) #t:転置なし+転置あり

## バブルチャート

gChart(s=1) #s=1/'b':バブルチャート
gChart(s=1,lx='地域',ly='単語')           #ラベル
gChart(s=1,lx='地域',ly='単語',lg='頻度') #ラベル,lg:凡例
gChart(s=1,X='w2,w1,w3,w4',Y='B,A,C,D,E') #ラベル順
gChart(s=1,a=90) #a:ラベル角度=90
gChart(s=1,f=15) #f:フォントサイズ=15
gChart(s=1,b=10) #b:バブルサイズ=10
gChart(s=1,w=T) #w:白黒=T
gChart(s=1,k=F) #数値なし(k=T:デフォルト)
gChart(s=1)+gChart(s=1,t=T) #t:転置

## さまざまなチャート

gChart(s=0) #ヒートチャート
gChart(s=1) #バブルチャート
gChart(s=2) #バブルフィルドチャート
gChart(s=3) #スクエアチャート
gChart(s=4) #スクエアフィルドチャート

gChart(s='h') #ヒートチャート
gChart(s='b') #バブルチャート
gChart(s='bf') #バブルフィルチャート
gChart(s='s') #スクエアチャート
gChart(s='sf') #スクエアフィルチャート

## 大きな数値行列

D=Ip('santander-m') #大きな数値行列 Matriz grande
gChart(s=0) #ヒートチャート

#### 分布 ####

## 散布図
#gPoint(E=D,x=1,y=2,g=0,lm='',lx='',ly='',lg='',r=F,s=1,w=F,f=12,
#Lx=F,Ly=F,z=F,a=0,p='vh',d='both')
#E:,x:x軸,y:y軸,g:グループ軸,lm,lx,ly,lg:ラベル,r:行名,s:ポイントサイズ,
#w: 白黒,f:フォントサイズ,Lx:対数軸(x),Ly:対数軸(y),z:両軸ゼロ開始,a:行名角度,
#p:配置('vh':平面,'v':縦図,'h':横図,d:行名の位置調整('both','x','y')

Dt(iris) #データ例:アヤメの萼片と花弁 (df) nr=150

gPoint(iris,'Sepal.L','Sepal.W') #x,y:アヤメの萼片の長さ・幅
gPoint(iris,1,2)                 #x,y:列番号で指定(同)
gPoint(iris,1,2,5)               #g:グループ軸=5
gPoint(iris,1,2,'Sp')            #g:グループ軸='Sp'(同)
gPoint(iris,1,2,5,z=T)           #z:両軸ゼロ開始
gPoint(iris,1,2,5,s=2)           #s:ポイントサイズ=2
gPoint(iris,1,2,5,f=15)          #f:フォントサイズ=15
gPoint(iris,1,2,5,w=T)           #w:白黒
gPoint(iris,1,2,5,lm='Iris', lx='Sepal length',ly='Sepal width') #ラベル

Dt(diamonds)          #ダイアモンド
gPoint(diamonds,x='ca',y='pr',g='co') #7 sec.

D=decathlon2; Dt()    #データ例:十種競技(df) nr=27
gPoint()          #デフォルト(g=0:グループなし,r=F:行名なし)
gPoint(g='C')     #g=C:グループ: [C]ompetition
gPoint(r=T)       #r=T:行名あり
gPoint(g='C',r=T) #g=C:グループ: [C]ompetition, r=T:行名あり

gPoint(p='v')           #p:配置='v':縦図
gPoint(p='v',r=T)       #p:配置='v':縦図, r=T:行名あり
gPoint(p='v',g='C')     #p:配置='v':縦図, g=C:グループ: [C]ompetition
gPoint(p='v',g='C',r=T) #p:配置='v':縦図, g=C:グループ: [C]ompetition, r=T:行名あり

gPoint(w=T)                    #両軸 (v1=1,v2=2, w=T:白黒)
gPoint(g='C',lg='Competition') #両軸 (x=1,y=2, lg:凡例)
gPoint(g='C',lg='Competition',s=2)    #s:ポイントサイズ=2
gPoint(g='C',lg='Competition',s=2.5)  #s:ポイントサイズ=2.5
gPoint(g='C',lg='Competition',s=3)    #s:ポイントサイズ=3

D=USArrests; Dt()      #データ例:米国の暴力犯罪率(df) nr=50
gPoint()                    #デフォルト(x=1,y=2,r=F:行名なし)
gPoint(x='M',y='A',r=T)     #x軸g=[M]urder, y軸=[A]ssault, r=T:行名あり
gPoint(x='M',y='R',r=T)     #x軸g=[M]urder, y軸=[R]ape, r=T:行名あり
gPoint(x='M',y='U',r=T)     #x軸g=[M]urder, y軸=[U]rbanPop, r=T:行名あり

## ボックスグラフ
#gBox(df=D,y=1,g=NULL,p=NULL,lm='',lx='',ly='',lg='',y1=0,y2=0,a=0,f=12,l=F,z=F,w=F)
#df,y:y軸,g:グループ列,p:ポイント表示,lx,ly,lg:ラベル,y1,y2:y軸範囲,w:白黒
#lx:ラベルx,ly:ラベルy,lg:ラベルg，y1:y軸下限，y2:y軸上限，
#a:横軸名角度,f:フォントサイズ,l:対数軸,z:軸ゼロ開始w: 白黒

gBox(iris,'Sepal.Length') #データ: iris, 列:'Sepal.Length'
gBox(iris,1) #同
gBox(iris,1,5) #同+g:グループ列=5
gBox(iris,1,5,p=T) #同+p:ポイント表示+T
gBox(iris,1,5,p=T,w=T) #同+w:白黒+T
gBox(iris,1,5,p=T,lx='がくの長さ',ly='単位: cm') #同+lx:ラベル(x)
gBox(iris,1,5,p=T,lm='Iris',lx='Sepal length',ly='Unit : cm',lg='Iris species',y1=0,y2=10) #同+範囲(y1,y2)

Dt(diamonds) #データ: diamonds
gBox(diamonds,1,2,p=T) #7 sec.

## グラフ保存
#gSave(p=G,f='x.jpg',w=30,h=20,d=600)
#p:グラフオブジェクト,f:ファイル名,w:幅(cm),h:高さ(cm),d:dpi
G=gPoint(iris,'Sepal.L','Sepal.W') #x,y:アヤメの萼片の長さ・幅
G
gSave(f='@1.jpg',w=20,h=15,d=300) #Gを保存, f:ファイル名,w:幅(cm),h:高さ(cm)
gSave(G,'@1.jpg',20,15,300) #同


