##F.R 関数ファイル Fichero de funciones ## (v.2021/12/23)

#### データ処理関数 (A-F) #####
add=function(s1,s2,s3='',s4='',s5='',s6='',s7=''){paste0(s1,s2,s3,s4,s5,s6,s7)
} #文字列s1にs2を付加(繋ぐ)
addA=function(A=D,x){A[length(A)+1]=x; A
} #配列に要素を追加
AsC=function(n){as.character(n)
  } #数値=>文字
AsN=function(s){as.numeric(s)
} #文字列=>数値
Ca=function(){Cc(); Cp(); Cw(); source('S.R'); Start()
} #クリアオール(コンソール;プロット;ワークスペース); スタート
Cc=function(){cat("\014")
} #クリアコンソール Clear console
Cn=function(X=D,N=0){if(is_null(colnames(X))) return(NULL)
  if(N[1]==0) N=1:ncol(X); R=N; 
  for(i in 1:length(N)){R[i]=colnames(X)[i]}; R
} #列名(1行でも可) cf Rn
col2n=function(d=D,x){ifelse(IsNum(x),x,Fn(x,colnames(d),T))
} #列名=>列番号
ColN=function(E=D){colnames(D)=add('v',1:ncol(D)); D
} #列名=>v1, v2, ...
colnam=function(d,x){
  if(is.null(x)) return(x)
  if(IsNum(x)){x=colnames(d)[x]}; x
} #列番号->列名
Cols=function(M=D,x=1){
  if(is_null(x)) return(x)
  Ie(isN(x), x, Fn(x,Cn(M))) #フルネーム(r)
} #数値/列頭文字=>列名
Cp=function () {if( dev.cur() > 1 ) dev.off()
} #クリアプロット Clear plot
Cr=function(n=1){cat(rep('\n',n))
} #改行出力 n:改行数
Cw=function(){rm(list=ls(envir=globalenv()),envir=globalenv())
} #クリアワークスペース Clear work space
Dat=function(M=D,s='',r='',c='',sr=NULL,sc=NULL,d=F,n=F){ #NEW, r/c:文字列
  if(!is_null(sr)|!is_null(sc)) return(Sort(M,sr,sc,d,n)) #ソート
  if(s!='') {return(Ext(M,s))} #抽出
  if(isN(r)) {if(r[1]==0) r=1:nrow(M)} #デフォルト:全行
  if(isN(c)) {if(c[1]==0) c=1:ncol(M)} #デフォルト:全列
  if(!isN(r)) {r=Ie(r=='',1:nrow(M),S2A(r))} #デフォルト:全行/~指定行
  if(!isN(c)) {c=Ie(c=='',1:ncol(M),S2A(c))} #デフォルト:全列/~指定列
  if(!isN(r)) r=Fn(r,Rn(M)) #フルネーム(r)
  if(!isN(c)) c=Fn(c,Cn(M)) #フルネーム(c)
  R=M[r,c]; S=R #抽出
  if(length(r)==1) {#1行の処理
    S=matrix(R,1)
    if(!is_null(Cn(M))) colnames(S)=Cn(M,c)
    if(!is_null(Rn(M))) rownames(S)[1]=Rn(M)[r]}
  if(length(c)==1) {#1列の処理
    S=matrix(R,length(R))
    if(!is_null(Rn(M))) rownames(S)=Rn(M,r)
    if(!is_null(Cn(M))) colnames(S)[1]=Cn(M)[c]}
  S #出力
} #データ抽出・ソート(df,mt) ex.Dat(D,'ca>=0.5','2,3','A,C'): 行列Dの2,3行，A,C列を抽出
#例　s:'ca>=0.5', r:'2,3', c:'A,C sr:'', sc:'', d:T
#s:条件抽出(select), r:行抽出, c:列抽出 sr:行ソート, sc:列ソート, d:降順, n:数値処理
Dt=function(E=D,r=10,c=0,n=F,rn=F,cn=F,d='',j=F){
  # D:データ, r:行数,c:列数,n:行/列名,rn:行名,cn:列名,d:データ名など,j:右揃え
  if(is.null(nrow(E))&is.null(ncol(E))) {cat(d,'Class: ',class(E),': ',E,sep='') #Eがスカラーならば
  } else { #Eがmatrix, df, tableならば
    cat(d,'Class: ',Str(class(E)),' / Rows: ',nrow(E),' / Columns: ',ncol(E),sep='')
    E=as.data.frame(E)
    Cr(2)
    if(IsT(E)) E=T2M(E) #Eがtableならば行列に
    if(r==0|r>nrow(E)) r=nrow(E); if(c==0|c>ncol(E)) c=ncol(E) #行数/列数
    E=Dat(E,'',1:r,1:c)
    if(!IsJpD(E)) E=format(E,justify='left')
    print(E,right=j) #右揃え(T/F)
  } #先頭行/列抽出
  if(n) {Cr(1); cat('Row names:',Sn(Rn(E))); Cr(2); cat('Column names:',Sn(Cn(E)))}
  if(rn) {Cr(1); cat('Row names:',Sn(Rn(E)))}
  if(cn) {Cr(1); cat('Column names:',Sn(Cn(E)))}
} #データ表示

xDt=function(E=D,r=10,c=0,n=F,rn=F,cn=F,d='',z=F){
  # Dt(E=D,r=10,c=0,n=F,rn=F,cn=F,d='')
  # D:データ, r:行数,c:列数,n:行/列名,rn:行名,cn:列名,d:データ名など
  if(is.null(nrow(E))&is.null(ncol(E))) {cat(d,'Class: ',class(E),': ',E,sep='') #Eがスカラーならば
  } else { #Eがmatrix, df, tableならば
    cat(d,'Class: ',Str(class(E)),' / Rows: ',nrow(E),' / Columns:',ncol(E),sep='')
    Cr(2)
    if(IsT(E)) E=T2M(E) #Eがtableならば行列に
    if(r==0|r>nrow(E)) r=nrow(E); if(c==0|c>ncol(E)) c=ncol(E) #行数/列数
    #print(noquote(Dat(E,'',1:r,1:c))) #先頭行/列抽出
    #print(JustD(Dat(E,'',1:r,1:c),z))
    print(Dat(E,'',1:r,1:c))
  } #先頭行/列抽出
  if(n) {Cr(1); cat('Row names:',Sn(Rn(E))); Cr(2); cat('Column names:',Sn(Cn(E)))}
  if(rn) {Cr(1); cat('Row names:',Sn(Rn(E)))}
  if(cn) {Cr(1); cat('Column names:',Sn(Cn(E)))}
} #データ表示
Detect=function(X,r){str_detect(X,r)
} #Xはrにマッチするか
Digit=function(X=D,d){
  noquote(format(X, digits = d+1))
} #小数表示(引用符なしの文字列)
Edit=function(X=D){edit(X)} #Edit
Eval=function(s){eval(parse(text=s))
} #文字列(s)をRスクリプトとして実行
Ext=function(E=D,s='v1>0'){
  s=gsub('==','=',s); s=gsub('([^<>])=','\\1==',s) #==に統一
  C=Cn(E); E=ColN()  #列名保持; 列名=>v1, v2, ...
  sb=gsub(' *([&|,]) *','\\1',s) #&,|の左右の空白除去
  sb=gsub('([=<>]=|[<>])([^&|,]+)( *[&|,]* *)',"\\1'\\2'\\3",sb) #Ideal => 'Ideal'
  Sp=Split(sb,',')
  for(i in 1:length(Sp)){
    Sq=Split(Sp[i],' *([=<>]=|[<>#]) *')            # ==, >などでスプリット
    sp=gsub('.*([=<>]=|[<>#]).*','\\1',Sp[i]) #sp:セパレータ
    vv=gsub('^v','',Sq[1])                   #語頭の'v'除去
    if(vv==''|IsStr(vv)){Sq[1]=add('v',Fn(vv,C,T))} #列名イニシャル=>v+列番号
    if(sp!='#') Sp[i]=Join(Sq,sp) #Sqをspで繋ぐ: v1=='E'
    if(sp=='#') Sp[i]=add("Detect(",Sq[1],",'",Sq[2],"')") #Detect(v4,"^S")
  }
  sc=Join(Sp,'&'); sc=add("subset(E,",sc,")")
  S=eval(parse(text=sc)); colnames(S)=C; S #スクリプト実行; 列名；出力
} #データ抽出 extract Ext([D],s='v1=0', 'v1>5,v1<10','v=='Good', etc)
Extract=function(s,r){str_match(s,r)[2]
} #文字列sの中で正規表現(r)にマッチする文字列
File=function(f=''){
  if(!Match('\\.txt',f)) f=add(f,'.txt') #ファイル名に'.txt'を付加
  file.edit(f) #エディット
} #ファイル編集 (スクリプト画面)
ff=function(E=D){as.data.frame(E)
} #データフレームに
Fn=function(str,C,s=F){
  S=spl(str); R=NULL; for(i in 1:length(S)){for(j in 1:length(C)){
    if(str_detect(C[j],add('^',S[i]))){R=addA(R,ifelse(s,j,C[j])); break}
  }}; R
}#語頭文字(列)=>フルネーム (s=T: 列番号)
#### データ処理関数 (I-N) ####
Ie=function(C,Y,N){if(C) R=Y else R=N; R
} #like ifelse (C:条件,X,Y:行列/オブジェクト)
IniSch=function(Str,Ini){
  R=rep('N',length(Str))
  for(i in 1:length(Str)){for(j in 1:length(Ini)){
    if(str_detect(Str[i],add('^',Ini[j]))){R[i]=Ini[j]}}}; R #語頭一致
} #語頭探索 initial search (Str:対象文字ベクトル, Ini:探索文字ベクトル)
Ip=function(f=''){
  if(f!=1&f!='1'&f!=''&!Match('\\.txt',f)) f=add(f,'.txt') #ファイル名に'.txt'を付加
  if(f==1|f=='1') f=file.choose() #ファイル選択
  if(f=='') {R=readClipboard(format=13); Encoding(R)='UTF-8' #クリップボード
  }else     {R=readLines(f,encoding='UTF-8')} #ファイル指定/選択
  r=length(R); c=length(spl(R[1],'\t')); E=Mt(r,c) #行列用意
  for(i in 1:r){A=spl(R[i],'\t'); for(j in 1:c){E[i,j]=A[j]}} #行列要素
  r=nrow(E); c=ncol(E) #行数; 列数
  R=Dat(E,r=2:r,c=2:c) #行列データ抽出
  if(!IsJpD(R)) R=as.data.frame(R) #日本語でなければ=>df(引用符除去)
  for(i in 1:ncol(R)){if(IsNum(R[,i])[1]) R[,i]=as.numeric(R[,i])}
  rownames(R)=E[,1][2:r]; colnames(R)=E[1,][2:c] #行名; 列名
  if(f=='') f='Copy'
  f=gsub('\\','/',f,fixed=T); f=gsub('.*/','',f) #ファイル名
  Dt(R,d=add('File: ',f,' / '));  R #データ表示; 出力
} #データ入力 Ip():コピーデータ, Ip(1):ファイル選択, Ip('x.txt'):ファイル指定
Ipj=function(fn='clipboard'){
  con=file(fn,encoding='UTF-8'); on.exit(close(con))
  ln=readLines(con); nr=length(ln); nc=length(spl(ln[1],'\t'))
  mt=spl(ln,'\t'); mm=matrix(0,nr,nc)
  k=0; for(i in 1:nr){for(j in 1:nc){k=k+1; mm[i,j]=mt[k]}}
  dd=mm[-1,-1]; R=as.numeric(dd); R=matrix(R,nrow(dd))
  rownames(R)=mm[-1,1]; colnames(R)=mm[1,-1]; R
}#データ入力 (fn: 日本語 tsv)
Ipm=function(fn=''){
  if(fn=='') E=read.table(pipe('pbpaste'),header=T) #コピーデータ MAC
  if(fn==1){E=read.table(file.choose(),header=T,sep='\t',encoding='UTF-8') #ファイル選択
  }else    {E=read.table(fn,header=T,sep='\t',encoding='UTF-8')} #ファイル指定
  if(IsStrM(E[,-1])){ #データフレーム
    return(E)
  }else{ #数値行列
    R=as.numeric(as.matrix(E[,-1])); R=matrix(R,nrow(E)) #行列化
    colnames(R)=colnames(E[,-1]); rownames(R)=E[,1]; return(R)
  }
} #データ入力(MAC) Ip():コピーデータ, Ip(1):ファイル選択, Ip('x.txt'):ファイル指定
xIpm=function(fn='c'){ #データ入力 (fn=1: ファイル選択) MAC
  if(fn==1) E=read.table(file.choose(),header=T) #ファイル選択
  if(fn=='c'){E=read.table(pipe('pbpaste'),header=T) #コピー MAC
  }else        {E=read.table(fn,header=T)} #クリップボート
  if(IsStrM(E[,-1])){ #文字を含むデータフレーム
    R=format(E,justify='left')
  }else{ #数値行列
    R=as.numeric(as.matrix(E[,-1])); R=matrix(R,nrow(E)) #データ読み込み; 行列化
    colnames(R)=colnames(E[,-1]); rownames(R)=E[,1]
  };  R
}
IsIn=function(x, C){x %in% R
} # xが配列Cに存在: x in C =>T
IsJp=function(C){T %in% str_detect(C,'\\p{Hiragana}|\\p{Katakana}|\\p{Han}')
} #配列C|strに日本語が存在
IsJpD=function(E=D){
  flg=F; for(i in 1:min(nrow(E),5)){
    if(IsJp(E[i,])) {flg=T; break}
  }; flg
} #D:df,mtに日本語が存在
IsM=function(E=D){'matrix' %in% class(E)
} #matrix判定
IsN=function(E=D){!IsM(E)&!IsD(E)&!IsT(E)
} #数値(スカラー)判定
isN=function(x){is.numeric(x)
} #数値(スカラー)判定
IsNum=function(x){
  (x!='') & (gsub('(\\d+|[0-9.,]+| +)','',x)=='')
} #数値判定('1.2'=>TRUE)
IsD=function(E=D){'data.frame' %in% class(E)
} #data.frame判定
IsStr=function(x){!IsNum(x)
} #文字判定
IsStrM=function(X){f=F; for (i in 1:nrow(X)){ for (j in 1:ncol(X)){
  if(IsStr(X[i,j])){f=T; break}
}; if(f){break} }; f
} #文字判定 (行列)
IsStrA=function(A){f=F; for (i in A){if(IsStr(i)){f=T; break}}; f
} #文字判定 (配列)
IsT=function(E=D){'table' %in% class(E)
} #table判定
Join=function(C=A,s=','){paste(C,collapse=s)
} #配列要素をsで繋ぐ
JustD=function(R=D, z=F){ #v.2021-12026
  X=Trim(N2S(R))
  for(i in 1:ncol(X)){intmx=0; decmx=0
    for(j in 1:nrow(X)){s=X[j,i]
      if(IsNum(s)&Detect(s,'\\.')) {
        intx=nchar(Extract(s,' *(\\d+)\\.'))
        decx=nchar(Extract(s,'\\.(\\d+)$'))
      }else{intx=nchar(s); decx=0}
      if(intx>intmx) {intmx=intx}
      if(decx>decmx) {decmx=decx}
    }
    for(j in 1:nrow(X)){s=X[j,i]
      if(IsNum(s)&Detect(s,'\\.')) {
        intx=nchar(Extract(s,' *(\\d+)\\.'))
        decx=nchar(Extract(s,'\\.(\\d+)$'))
        if(z)  X[j,i]=add(RepStr(' ',intmx-intx),s,RepStr('0',decmx-decx))
        if(!z) X[j,i]=add(RepStr(' ',intmx-intx),s,RepStr(' ',decmx-decx))
      }
      if(IsNum(s)&!Detect(s,'\\.')) {
        intx=nchar(s)
        if(z)  X[j,i]=add(RepStr(' ',intmx-intx),s,' ',RepStr('0',decmx))
        if(!z) X[j,i]=add(RepStr(' ',intmx-intx),s,RepStr(' ',decmx))
      }
    }
  };  noquote(X)
} #小数点揃え justification by decimal point
Jp=function(){
Sys.setlocale("LC_ALL", 'Japanese_Japan.932') 
} #日本語文字設定
Match=function(r,str){regexpr(r,str)[1]>0
} #パタンマッチ=>T/F
Mt=function(r,c){matrix(rep(0,r*c),r)
} #行列用意
n2col=function(d=D,x){ifelse(IsStr(x),Fn(x,colnames(d)),colnames(d)[x])
} #列番号=>列名
#### データ処理関数 (O-*) ####
Op=function(X=D,f=''){
  if(f!=1&f!='1'&f!=''&!Match('\\.txt',f)) f=add(f,'.txt') #ファイル名に'.txt'を付加
  if(f==1|f=='1') f=file.choose() #ファイル選択
  if(f!='') { #ファイル名指定
    B=rbind(colnames(X),X)       #列名=>表頭
    B=cbind(c('*',rownames(X)),B)#行名=>表側
    readr::write_tsv(as.data.frame(B),f,col_names=F) #行列(TSV)出力
  } else{ #クリップボード
    if(IsJpD(X)) {str=Trim(M2S(X)); writeClipboard(str,format=13) #str:文字列(TSV)出力
    }else write.table(X,file='clipboard-20000',sep='\t',col.names=NA,quote=F)
  }
  if(f=='') f='Copy'; Dt(X,d=add('File: ',f,' /')) #データ表示
} #テキストファイル(TSV)出力 Op():コピー, Op(X):データ指定, Op(D,1):データ選択
#例: Op(f='a.txt'), Op(D,'a.txt')=Op(D,'a'), Op(D,1)=Op(D,'1')
Opj=function(X=D,f=''){
  if(f!=1&f!='1'&f!=''&!Match('\\.txt',f)) f=add(f,'.txt') #ファイル名に'.txt'を付加
  if(f==1|f=='1') f=file.choose() #ファイル選択
  if(f!='') { #ファイル名指定
    B=rbind(colnames(X),X)       #列名=>表頭
    B=cbind(c('*',rownames(X)),B)#行名=>表側
    readr::write_tsv(as.data.frame(B),f,col_names=F) #行列(TSV)出力
  } else{ #クリップボード
    str=Trim(M2S(X)) #行列=>文字列(TSV)=>トリム
    writeClipboard(str,format=13)} #str:文字列(TSV)出力
  if(f=='') f='Copy'; Dt(X,d=add('File: ',f,' /')) #データ表示
} #テキストファイル(TSV)出力 Op():コピー, Op(X):データ指定, Op(D,1):データ選択
#例: Op(f='a.txt'), Op(D,'a.txt')=Op(D,'a'), Op(D,1)=Op(D,'1')
Opm=function(X=D,fn='c'){
  if(mode(X)=='numeric'){ #数値行列
    R=rbind(colnames(X),X); R=cbind(c('*',rownames(X)),R)#行列に表頭・表側を追加
  }else {R=X} #文字を含むデータフレーム
  if(fn=='c'){write.table(R,file=fn,sep='\t',quote=F,row.names=F,col.names=F)
  }else {write.table(R,file=pipe('pbcopy'),sep='\t',quote=F,row.names=F,col.names=F)} #行列出力
} #テキストファイル出力 MAC
Ops=function(X,Y,fileN='clipboard'){
  A=rbind(colnames(X),X); A=cbind(c('*',rownames(X)),A) #行列に表頭・表側を加える
  B=rbind(colnames(Y),Y); B=cbind(c('*',rownames(Y)),B) #行列に表頭・表側を加える
  C=data.frame(A,rep('',nrow(Y)+1),B)
  write.table(C,file=fileN,sep='\t',quote=F,row.names=F,col.names=F) #行列出力
} #2表の連結を出力
Order=function(A,d=F){
  
  order(A,decreasing=d)
} #順番, d=T: decreasing
perfect_match=function(str,rx='(\\d+|[0-9]+)'){
  str_replace_all(str,rx,'')==''
} #完全一致(数値)
ReplaceAr=function(A=D,r,ic=F,ini=F){
  for (i in 1:length(A)){A[i]=ReplaceStr(A[i],r,ic,ini)}; A
} #配列Aの全要素をr='p1=>r1,p2=>r2'で置換; ic=T:大小文字区別なし; ini:語頭一致
ReplaceCol=function(d=D,c,r){
  P=spl(r,',+'); if(IsNum(c)) c=colnames(d)[c]
  for(i in 1:length(P)){
    p=spl(P[i],'=>'); if(is.na(p[2])) p[2]=''
    d[c]=lapply(d[c],gsub,pattern=p[1],replacement=p[2])
  }; d
} #Dのc列をrで置換(例:r='0=>v,1=>s')
ReplaceStr=function(str,r,ic=F,ini=F){
  P=spl(r); for (i in 1:length(P)){
    p=spl(P[i],'=>'); if(is.na(p[2])){p[2]=''}
    if(ini & str_detect(str,add('^',p[1]))){str=p[2] #語頭一致
    }else {str=gsub(p[1],p[2],str,ignore.case=ic)}
  }; str
} #文字列strをr='p1=>r1,p2=>r2'で置換; ic=T:大小文字区別なし; ini:語頭一致
RepC=function(A=D,r){matrix(rep(A,r),length(A))} #列繰り返し(A:配列, r:列数)
RepR=function(A=D,r){t(RepC(A,r))}               #行繰り返し(A:配列, r:行数)
RepStr=function(s,t){paste0(rep(s,t),collapse ='')
} #同文字連続(s:文字, t:回数)
Rmd=function(fn){
  rmarkdown::render(fn)
} #R Markdown Rmd => Html
Rn=function(X=D,N=0){if(is_null(rownames(X))) return(NULL)
  if(N[1]==0) N=1:nrow(X); R=N
  for(i in 1:length(N)){R[i]=rownames(X)[i]}; R
} #行名(1列でも可) cf Cn
Round=function(X=D,d='m=1'){ #v.2021-12-26
  if(IsNum(d)) return(round(as.numeric(X),d)) #数値スカラー
  Rn=rownames(X); X=as_tibble(X)
  for(d in Split(d)){
    x=AsN(Extract(d,'[mcr](.*?)=')); y=AsN(Extract(d,'=(.*?)$'))
    if(Detect(d,'^m')) X=mutate_if(X,is.numeric,round,y)
    if(Detect(d,'^c')) X[,x]=mutate_if(X[,x],is.numeric,round,y)
    if(Detect(d,'^r')) X[x,]=mutate_if(X[x,],is.numeric,round,y)
  }; X=as.data.frame(X); rownames(X)=Rn; X
} #小数桁数#
xRound=function(X=D,d='m=1',z=F){ #v.2021-12-26
  if(IsNum(d)) return(noquote(format(round(as.numeric(X),d),nsmall=d))) #数値スカラー
  R=X
  for(d in Split(d)){
    if(Detect(d,'^m')) { #行列
      y=AsN(Extract(d,'=(.*?)$')); R=format(round(as.numeric(R),y),nsmall=y)
      R=matrix(R,nrow(X)); rownames(R)=Rn(X); colnames(R)=Cn(X)
    }
    if(Detect(d,'^c')) { #列
      x=AsN(Extract(d,'c(.*?)=')); y=AsN(Extract(d,'=(.*?)$'))
      R[,x]=noquote(format(round(as.numeric(Dat(R,c=x)),y),nsmall=y))}
    if(Detect(d,'^r')) { #行
      x=AsN(Extract(d,'r(.*?)=')); y=AsN(Extract(d,'=(.*?)$'))
      R[x,]=noquote(format(round(as.numeric(Dat(R,r=x)),y),nsmall=y))}
    R=noquote(R)
  }
  #  R
  JustD(Trim(R),z)
} #小数桁数#
#d: 'm-1,c1=2,r2=3' (全体1桁, 1列2桁, 2行3桁), z:'0'を埋める
same=function(A,B){ fl=T; for (i in 1:length(A)){if(A[i] !=B[i]){fl=F; break}}; fl
} # ベクトル同一判定
Sn=function(V){for(i in 1:length(V)){V[i]=add(i,'.',V[i])}; V
} #連番.要素
Sort=function(M=D,r=NULL,c=NULL,d=F,n=F){
  if(!is_null(c)) {c=rev(c); for(i in 1:length(c)) M=SortC(M,c[i],d,n)}
  if(!is_null(r)) {r=rev(r); for(i in 1:length(r)) M=SortR(M,r[i],d,n)}; M
} #行列ソート
# Sort(M=D,r=NULL,c=NULL,d=F)
# D:データ行列,r:ソートキー番号(行),c:r:ソートキー番号(列),d:降順
SortC=function(M=D,x=NULL,d=F,n=F){
  if(is_null(x)) return(M)
  M=as.data.frame(M) #dfとする
  if(!isN(x)) x=Fn(x,Cn(M)) #xが数値でなければ列名とする
  A=Ie(x==0, rownames(M), M[,x]) #行名or列でソート
  if(n) A=as.numeric(A) #数値とする
  M[Order(A,d),] #順位に従って並べ替え
} #列番号で行をソート(M:行列・DF,x=1:列番号,d=T:降順,n=T:数値処理)
xSortC=function(M=D,x=NULL,d=F){
  if(is_null(x)) return(M)
  M=as.data.frame(M)
  if(!isN(x)) x=Fn(x,Cn(M))
  if(x==0){M=M[order(sort(rownames(M),d)),]; return(M)} ## 行名でソート
  if(d){M=M[order(-M[,x]),]}else {M=M[order(M[,x]),]}; return(M)
} #列番号で行をソート(M:行列・DF,x=1:列番号,d=T:降順)
xSortC=function(M=D,x=NULL,d=F){
  if(is_null(x)) return(M)
  M=as.data.frame(M)
  if(!isN(x)) x=Fn(x,Cn(M))
  if(x==0){M=M[sort(rownames(M),d),]; return(M)} ## 行名でソート
  if(d){M=M[order(-M[,x]),]}else {M=M[order(M[,x]),]}; return(M)
} #列番号で行をソート(M:行列・DF,x=1:列番号,d=T:降順,n=T:数値処理)
SortR=function(M=D,x=NULL,d=F,n=F){
  t(SortC(t(M),x,d,n))
} #行番号で列をソート(M:行列・DF,x=1:行番号,d=T:降順,n=T:数値処理)
Sp=function(){
Sys.setlocale(category = 'LC_CTYPE', locale = 'spanish')
} #スペイン語文字設定
spl=Split=function(str,r=', *'){
  unlist(strsplit(str,r))
} #文字列をREでスプリット => 配列
spln=function(str){
  #as.numeric(unlist(strsplit(C, ', *')))
  as.numeric(spl(str))
} #文字列=>数値ベクトル ex '2,3,1' => c(2,3,1)
SplitAr=function(A=D,r='\\.',d=1){
  for (i in 1:length(A)){A[i]=spl(A[i],r)[d]}; A
} #配列Aの要素をrでスプリットしd番の要素を返す
Str=function(A=D){toString(A)
} #ベクトル=>文字列
Trim=function(str){
  #gsub('^([[:space:]]|(\r*\n*)+)|([[:space:]]|(\r*\n*)+)$','',str)
  #gsub('^([[:space:]]|\n+)|([[:space:]]|\n+)$','',str)
  gsub('^([[:space:]]+)|([[:space:]]+)$','',str)
} #トリム(前後の空白，タブ，改行を除去)
Uniq=function(E=D,x,y,n){
  if(x==0){ #1軸
    E=data.frame(v2=E[,y],n=E[,n]); colnames(E)=c('v2','n')
    E=E %>% group_by(v2) %>% summarise_all(sum) #Uniq-sum
  }else if(y==0){ #1軸
      E=data.frame(v1=E[,x],n=E[,n]); colnames(E)=c('v1','n')
      E=E %>% group_by(v1) %>% summarise_all(sum) #Uniq-sum
  }else{ #2軸
    E=data.frame(v1=E[,x],v2=E[,y],n=E[,n]); colnames(E)=c('v1','v2','n')
    E=E %>% group_by(v1,v2) %>% summarise_all(sum) #Uniq-sum
  }; E
} #ユニーク(sum)
Vname=function(v) {deparse(substitute(v))
} #変数名
#### データ変形関数 ####
xD2D=function(E=D,C='1,2,3'){
  if(IsNum(C)){C=as.numeric(spl(C))}else {C=Fn(C,colnames(E))}
  R=E[,C]
  if(length(C)==1){
    R=as.data.frame(R); c=C[1]
    if(IsNum(c)) colnames(R)=colnames(E)[c] else colnames(R)=c
  };  R
} #データフレーム=>データフレーム(s=T:v1,v2,n)
xD2Ds=function(E=D){
  R=T2D(D2T(E)); colnames(R)[ncol(R)]='N'; R=R[R$N>0,]
  R=Sort(R,c=1:(ncol(R)-1)); rownames(R)=1:nrow(R); R
}# データフレーム=>データフレーム+sum df=>df.sum
# D2Ds=function(E=D){R=T2D(D2T(E)); R=Sort(R,c=1:ncol(R)); rownames(R)=1:nrow(R); R
# }# データフレーム=>データフレーム+sum df=>df.sum
D2xyn=function(E=D,x=1,y=2,n=3,s=F){
  x=col2n(E,x); y=col2n(E,y); n=col2n(E,n) #列名=>列番号
  data.frame(E[,x],E[,y],E[,n])
} #データフレーム=>データフレーム(s=T:v1,v2,n)
D2M=function(E=D,r=1,c=2,f=3,ir=0,ic=0){
  #E,r:出力行となる入力列位置,c:出力列となる入力列位置
  #f:累積和とする入力列位置(f=0:個数),ir:rの間隔,ic:cの間隔
  E=as.data.frame(E); n=1; p=1 #Eに変換; n:出力行数; p:出力列数
  if(r>0 & ir>0) E[,r]=as.integer(E[,r]/ir)*ir #数値=>階級(r)
  if(c>0 & ic>0) E[,c]=as.integer(E[,c]/ic)*ic #数値=>階級(c)
  if(r>0){R=sort(unique(E[,r])); n=length(R)} #出力行
  if(c>0){C=sort(unique(E[,c])); p=length(C)} #出力列
  M=matrix(0,n,p)#出力行列
  if(r>0) rownames(M)=R else rownames(M)='*' #行名
  if(c>0) colnames(M)=C else colnames(M)='*' #列名
  for(i in 1:nrow(E)){
    x=ifelse(r>0,which(R==E[i,r]),1) #行
    y=ifelse(c>0,which(C==E[i,c]),1) #列
    if(f==0){M[x,y]=M[x,y]+1       #外的数値がなければ個数
    }else     {M[x,y]=M[x,y]+E[i,f]}#外的数値があれば累積和
  }
  if(ir>0&nrow(M)>1) rownames(M)=paste0(rownames(M),'-') #行間隔があれば軸に'-'を付加
  if(ic>0&ncol(M)>1) colnames(M)=paste0(colnames(M),'-') #列間隔があれば軸に'-'を付加
  t(M)
} #データフレーム=>数値行列
D2T=function(E=D){table(E)
} #データフレーム=>テーブル df=>tb
L2M=function(df=D,t=F){R=NULL
  for(i in 2:ncol(D)){
    X=xtabs(~df[,1]+df[,i])
    if(t) colnames(X)=paste0(colnames(df)[i],'.',colnames(X))
    R=cbind(R,X)
  }; R
} #文字行列(D:ex.santander.txt)=>数値行列
xL2M=function(df=D){R=NULL
  for(i in 2:ncol(D)){R=cbind(R,xtabs(~df[,1]+df[,i]))}; R
} #文字行列(D:ex.santander.txt)=>数値行列
M2D=function(X=D){
#  if(!IsM(X)) return(X) #行列でなければ終了
  if(is.null(nrow(X))){ #ベクトル
    n=length(X); R=matrix(0,n,2)
    for(i in 1:n){
      R[i,1]=names(X)[i]; R[i,2]=X[i]
    }
    rownames(R)=1:n; colnames(R)=c('v1','n'); R=as.data.frame(R)
    R[,2]=as.numeric(R[,2]); R
  }else{ #行列
    n=nrow(X); p=ncol(X); np=n*p; R=matrix(0,np,3); k=0
    for (i in 1:n){ for (j in 1:p){ k=k+1
    rn=Ie(is_null(rownames(X)),'*',rownames(X)[i])
    cn=Ie(is_null(colnames(X)),'*',colnames(X)[j])
    R[k,1]=rn; R[k,2]=cn; R[k,3]=X[i,j]
    }}
    rownames(R)=1:np; colnames(R)=c('v1','v2','n'); R=as.data.frame(R)
    R[,3]=as.numeric(R[,3]); R
  }; R
} #Matrix=>data frame
M2Dn=function(X=D){
  n=nrow(X); p=ncol(X); np=n*p; R=matrix(0,np,3); k=0
  for (i in 1:n){ for (j in 1:p){ k=k+1
  R[k,1]=i; R[k,2]=j; R[k,3]=X[i,j]
  }}; rownames(R)=1:np; colnames(R)=c('v1','v2','n'); as.data.frame(R)
} #Matrix=>data frame (numeric)
M2M=function(M=D,R=NULL,C=NULL){
  M=as.matrix(M)
  if(is.null(R)||R==0) R=1:nrow(M) #R=NULL or R=1ならは全行
  if(is.null(C)||C==0) C=1:ncol(M) #C=NULL or C=1ならは全列
  W=as.matrix(M[R,C])
  if(length(R)>1  & length(C)==1) colnames(W)=colnames(M)[C]
  if(length(R)==1 & length(C)>1){colnames(W)=rownames(M)[R]; W=t(W)}
  if(length(R)==1 & length(C)==1){
    rownames(W)=rownames(M)[R]; colnames(W)=colnames(M)[C]
  }; W
} #行列Mの要素R行(複数)，C列(複数)
M2S=function(X=D){
  B=rbind(colnames(X),X)       #列名=>表頭
  B=cbind(c('*',rownames(X)),B)#行名=>表側
  str=''; for(i in 1:nrow(B)){for(j in 1:ncol(B)){
    if(j==1) str=add(str,B[i,j]) else str=add(str,'\t',B[i,j])
    #  }; str=add(str,'\r\n')}; Encoding(str)='UTF-8'; str
  }; str=add(str,'\n')}; Encoding(str)='UTF-8'; str
} #行列=>文字列(TSV)
N2S=function(X=D){
  R=mapply(X, FUN=as.character); R=matrix(R,nrow(X))
  rownames(R)=Rn(X); colnames(R)=Cn(X); R
} #numeric Mt=>string Mt
Q2df=function(X){R=as.numeric(X); R=matrix(R,nrow(X))
rownames(R)=Rn(X); colnames(R)=Cn(X); as.data.frame(R)
} #quote => df
Q2M=function(X){R=as.numeric(X); R=matrix(R,nrow(X))
rownames(R)=Rn(X); colnames(R)=Cn(X); R
} #quote => df
S2A=function(str){
  s=gsub(',.*','',str)
  Ie(IsNum(s),spln(str),spl(str))
} #文字列=>配列 string to array ex.'2,3,5'=>c(2,3,5); 'a,b,c'=>c('a','b','c')
S2N=function(X=D){
  R=as.numeric(X); R=matrix(R,nrow(X)) 
#  R=mapply(X, FUN=as.numeric)
  rownames(R)=Rn(X); colnames(R)=Cn(X); R
} #string Mt=>numeric Mt
Str2Var=function(str){eval(parse(text=str))
} #string=>variable
T2D=function(E=D){data.frame(E)
} #テーブル=>データフレーム tb=>df
T2E=function(E=D){expand.table(E)
} #テーブル=>展開データフレーム tb=>expanded df
T2M=function(E=D){
  M=matrix(as.numeric(E),nrow(E),ncol(E))
  rownames(M)=rownames(E); colnames(M)=colnames(E); M
} #テーブル=>数値行列 table=>matrix
Var2Str <- function(v) {deparse(substitute(v))
} #variable=>string
Vista=function(X=D){View(X)} #画面表示
#### 統計関数 (A-D) ####
aa=function(X,Y){return (MV(X,Y,'a'))
} #行列・ベクトルの足し算 X+Y
AM=function(M=D,s='a'){M=as.matrix(M)
  W=1-M; A=t(M)%*%M; B=t(M)%*%W; C=t(W)%*%M; D=t(W)%*%W
  if(s=='a') R=A#共起回数
  if(s=='s')R=(A+D)/(A+B+C+D)#Simple
  if(s=='j') R=A/(A+B+C)#Jaccard
  if(s=='d') R=2*A/(2*A+B+C)#Dice
  if(s=='h') R=((A+D)-(B+C))/((A+D)+(B+C))#Hamann
  if(s=='y') R=(A*D-B*C)/(A*D+B*C)#Yule
  if(s=='p') R=(A*D-B*C)/((A+B)*(C+D)*(A+C)*(B+D))^(1/2)#Phi
  if(s=='o') R=A/((A+B)*(A+C))^(1/2)#Ochiai
  if(s=='u') R=(2*A-B-C)/(2*A+B+C)#Ueda
  if(s=='mi') R=log2(A*(A+B+C+D)/((A+B)*(A+C)))#相互情報量
  if(s=='rmi') R=log(A*(A+B+C+D)/((A+B)*(A+C)))/log((A+D)/A)#相対相互情報量
  if(s=='ss') R=A/(A+B)#単純選択
  if(s=='cs') R=(A*D-B*C)*(A+D)/(D*(A+B)*(A+B+C+D))#比較選択
  R
}#連関行列(Association matrix)

balance=function(A=D){A=A-median(A); p=sum(A[A>0]); n=-sum(A[A<0]); (p-n)/(p+n)
}#平衡係数(balance)
BinE=function(x,n,s=0.99){
  if(x==0) return(0)
  p=10 ^ 6; mx=p; mn=0; lw=s - 1/p; up=s+1/p
  #p:期待確率精度：mx:探索最大値，mn:最小値,lw:下側，up:上側
  for (c in 1:1000){
    i=(mx+mn) / 2;  R=i / p #中間値：期待確率候補
    sc=pbinom(x - 1,n,R)   #期待確率候補の有意率
    if(sc < lw){mx=i      #探索最大値を中間値まで下げる
    }else if(sc > up){mn=i #探索最小値を中間値まで上げる
    }else {break}
  }; R
} #二項分布期待確率 (x:出現数,n:試行数,s:信頼係数) ex:BinE(3,10,0.5) #0.258574486
central=function(A=D){A=A-mean(A); p=length(A[A>0]); n=length(A[A<0]); (p-n)/(p+n)
}#中心性係数(centrality)
cls=function(n){
  hcl(seq(15,375,length=n+1),100,35)[1:n]
} #色指定 (n: 色数)
COR=function(X=D,s=0){
  #s=0:相関行列; 1:共分散行列
  if(s==0){cor(X)
  }else {Z=apply(X,2,function(X){X-mean(X)}); t(Z) %*% Z / nrow(X)}
}#相関行列
CorrespDg=function(Dnp=D,d=3,op=0){
  Dnp=as.matrix(Dnp)
  nr=nrow(Dnp); nc=ncol(Dnp) #行数; 列数
  if(d<3&nc<3) d=1; if(d<3 & nr<3) d=2
  if(d==3){ #行・列を並べ替え
    Snn=diag(nr)/rowSums(Dnp) #行和逆数対角行列
    Tpp=diag(nc)/sqrt(colSums(Dnp)) #列和逆数対角行列
    App=Tpp%*%t(Dnp)%*%Snn%*%Dnp%*%Tpp #固有値方程式
#    E=eigen(App); Epp=E$vectors ; Rp=sqrt(E$values[1:min(nr,nc)]) #固有行列;固有値=>相関係数
    E=eigen(App); Epp=E$vectors ; Rp=sqrt(abs(E$values[1:min(nr,nc)])) #固有行列;固有値=>相関係数
    #Yp=(Tpp%*%Epp*sqrt(sum(Dnp))*RepR(Rp,nc))[,2] #Yp=Tpp Rpp*rs*Rp
    Yp=(Tpp%*%Epp*sqrt(sum(Dnp)))[,2] #Yp=Tpp Rpp*rs
    Xn=(Snn%*%Dnp%*%Yp/Rp[2]) #Xn=Snn Dnp Yp / Rp
    Dnp=Dnp[order(Xn),order(Yp)] #並べ替え
  }
  if(d==1|d==2){ #片側対応分析 (Ueda)
    if(d==2) Dnp=t(Dnp) #列の並べ替え=>転置
    Snn=diag(nrow(Dnp))/rowSums(Dnp) #行和逆数対角行列; 総和の根
    Yp=std(1:ncol(Dnp)); Xn=Snn%*%Dnp%*%Yp; Dnp=Dnp[order(Xn),] #連番標準化; 重み; 並べ替え
    if(d==2) Dnp=t(Dnp) #列の並べ替え=>転置
  } 
  # if(d==3){ #行・列を並べ替え
  #   CA=corresp(Dnp,min(nr,nc)); Xn=CA$rscore[,1]; Yp=CA$cscore[,1]
  #   Dnp=Dnp[order(Xn),order(Yp)] #並べ替え
  # }
#  rownames(Xn)=Rn(Dnp)
#  rownames(Yp)=Cn(Dnp)
  if(d==0|op==0) R=Dnp
  if(d>0&op==1) R=Ie(d==2,Yp,Xn)
  if(d>0&op==2) R=Ie(d==2,Xn,Yp)
  R #出力
} #対応分析.対角化(M:数値行列,d=0:なし,1:行,2:列,3:行列,op=0:Dnp,1:Xn,2:Yp)
CorrespSc=function(Dnp=D,s=0){
  Dnp=as.matrix(Dnp)
  nr=nrow(Dnp); nc=ncol(Dnp) #行数; 列数
  Snn=diag(nr)/rowSums(Dnp) #行和逆数対角行列
  Tpp=diag(nc)/sqrt(colSums(Dnp)) #列和逆数対角行列
  App=Tpp%*%t(Dnp)%*%Snn%*%Dnp%*%Tpp #固有値方程式
# E=eigen(App); Epp=E$vectors; Rp=sqrt(E$values) #固有行列;固有値=>相関係数
  E=eigen(App); Epp=E$vectors; Rp=sqrt(abs(E$values[1:min(nr,nc)])) #固有行列;固有値=>相関係数
  #CA=corresp(Dnp,min(nr,nc)); 
  #Rp=CA$cor #CA:対応分析(MASS); Rp:相関係数
  #Epp=CA$cscore #固有行列
  #Epp=eigen(App)$vectors #固有行列
  # Ypp=(Tpp%*%Epp*sqrt(sum(Dnp))*RepR(Rp,nc)) #Yp=Tpp Rpp*rs*Rp
  # Xnp=(Snn%*%Dnp%*%Ypp/RepR(Rp,nr)) #Xn=Snn Dnp Yp Dnp / Rp
  Ypp=(Tpp%*%Epp*sqrt(sum(Dnp))) #Yp=Tpp Rpp*rs*Rp
  Xnp=Snn%*%Dnp%*%Ypp[,1:min(nr,nc)]/RepR(Rp,nr) #Xn=Snn Dnp Yp Dnp / Rp
  rownames(Xnp)=Rn(Dnp); rownames(Ypp)=Cn(Dnp); Ie(s==0,Xnp[,-1],Ypp[,-1]) #行名; 出力
} #対応分析.行/列スコア (s=0/1) MASS:correspと同じ cf.CorrespRs(), CorrespCs()
CorrespEv=function(M=D){
  M=as.matrix(M)
  CA=corresp(M,min(nrow(M),ncol(M))) #対応分析(MASS)
  R=CA$cor; E=R^2; P=E/sum(E); C=cumsum(P) #R:相関係数,E:固有値,P:寄与率,C:累積寄与率
  data.frame(E=round(E,4),R=round(R,4),P=perc(P),C=perc(C)) #出力
} #対応分析 R:相関係数,E:固有値,P:寄与率,C:累積寄与率
CorrespRs=function(M=D){
  M=as.matrix(M); CA=corresp(M,min(nrow(M),ncol(M))); CA$rscore[,1]
} #対応分析1軸:行スコア
CorrespCs=function(M=D){
  M=as.matrix(M); CA=corresp(M,min(nrow(M),ncol(M))); CA$cscore[,1]
} #対応分析1軸:列スコア
count=function(A=D) {length(A)
} #個数
Cross=function(df=D,x=0,v=NULL,n=0,d=0,m=F,t=F){ #ver.2021-12-30
  #([df], x:個体列(単複), v:変数列(単複),n:数値列(単),m:平均値,t:入力列名付加)
  df=as.data.frame(df); R=NULL; S=NULL #準備
  x=Cols(df,x); v=Cols(df,v); n=Cols(df,n) #数値/列頭文字=>列名
  if(length(x)>1){ #複数個体
    for(i in 2:length(x)){
      df[,x[1]]=paste0(df[,x[1]],'_',df[,x[i]])
      colnames(df)[x[1]]=paste0(Cn(df)[x[1]],'_',Cn(df)[x[i]])
    }; x=x[1]
  }
  if(is_null(v)){ #1列(x)分析
    if(x==0&n==0) X=xtabs(~rownames(df))       #x==0: 行名, n==0: 個数
    if(x==0&n>0)  X=xtabs(df[,n]~rownames(df)) #x==0: 行名, n >0: 合計
    if(x>0&n==0)  X=xtabs(~df[,x])             #x >0: 列名, n==0: 個数
    if(x>0&n>0)   X=xtabs(df[,n]~df[,x])       #x >0: 列名, n >0: 合計
    R=matrix(X,length(X)); rownames(R)=Rn(X); colnames(R)='Sum'
  }else for(i in v){ #変数列数だけ繰り返す
    if(x==0&n==0) X=xtabs(~rownames(df)+df[,i])       #x==0: 行名, n==0: 個数
    if(x==0&n>0)  X=xtabs(df[,n]~rownames(df)+df[,i]) #x==0: 行名, n >0: 合計
    if(x>0&n==0)  X=xtabs(~df[,x]+df[,i])             #x >0: 列名, n==0: 個数
    if(x>0&n>0)   X=xtabs(df[,n]~df[,x]+df[,i])       #x >0: 列名, n >0: 合計
    if(t) colnames(X)=paste0(colnames(df)[i],'.',colnames(X)) #入力列名付加
    R=cbind(R,X)
  }
  if(m){ #平均値
    for(i in v){ #変数列数だけ繰り返す
      if(x==0) Y=xtabs(~rownames(df)+df[,i])       #x==0: 行名 : 個数
      if(x>0)  Y=xtabs(~df[,x]+df[,i])             #x >0: 列名 : 個数
      if(t) colnames(X)=paste0(colnames(df)[i],'.',colnames(X)) #入力列名付加
      S=cbind(S,Y)
    }; R=R/S
  }; R=round(R,d) #小数桁(d)で四捨五入
  Ie(IsStrA(Rn(R)),R,SortC(R,0,n=T)) #行名が数値であれば行名でソート
} #ピボットテーブル (文字行列=>数値行列)
xCross=function(df=D,x=0,y=0,n=0,d=0,sel=0){
  df=as.data.frame(df); if(x+y+n==0){x=1; y=2; n=3} # デフォルト軸
  N=Xtabs(df,x,y,0); S=Xtabs(df,x,y,n) #N:個数; S:和
  if(sel==0) R=N; if(sel==1) R=round(S,d); if(sel==2) R=round(S/N,d); T2M(R)
} #クロス集計
#(df=D:データフレーム,x=1:行,y=0:列,n=0:数値,d=0:小数桁,sel=0:個数,1:和,2:平均)
CS=function(X=D,f=mean,s=1,d=3){ #(f=mean,median,mid,max,min; sel=1:行； 2:列, d:小数桁)
  W=apply(X,s,function(X){X - f(X)})
  if(s==1) W=t(W); round(W,d) #横(sel==1)→転置
} #比較得点
dd=function(X,Y){return (MV(X,Y,'d'))
} #行列・ベクトルの割り算 X / Y
dg=function(E=D,x){noquote(format(round(E,x),nsmall=x))
} #小数桁数
Dm=function(M=D,md='e',s=F,t=F,d=3){
  md=Fn(md,c('canberra','euclidean','maximum','manhattan','minkowski')) #距離計測方法
  if(t) M=t(M); if(s) M=SS(M,2) #t:転置; s:正規化(列)
  round(as.matrix(dist(M,method=md,diag=T,upper=T)),d)
} #距離行列 (distance matrix)
#Dm(M=D,md='e',s=F,t=F,d=3)
#M:数値行列,s:正規化(列),t:転置,d:小数桁
#md:距離計測方法('[c]anberra','[e]uclidean'(def.),'[max]imum','[man]hattan','[mi]nkowski')
DM=function(X=D, d='e', s=F){
  #d='e':ユークリッド距離/'m':平均距離/'r':相対距離, s:標準化
  n=nrow(X); p=ncol(X); R=matrix(rep(0,p*p),p,p)
  colnames(R)=colnames(X); rownames(R)=colnames(X)
  if(s) X=dd(X,statis(X,1,'sdp')) # 標準化
  for(i in 1:p){for (j in 1:i-1){
    if(d=='e') R[i,j]= sum((X[,i]-X[,j])^2)^(1/2)   # d='e':ユークリッド距離
    if(d=='m') R[i,j]=(sum((X[,i]-X[,j])^2)/n)^(1/2)# d='m':平均距離
    if(d=='r') R[i,j]=sum((X[,i]-X[,j])^2)/(sum(X[,i]^2)+sum(X[,j]^2))# d='r'; 相対距離
    R[j,i]=R[i,j]
  }}; R
} #距離行列(Distance matrix)
xDM=function(X=D,s1='',s2='s'){
  n=nrow(X); p=ncol(X); R=matrix(rep(0,p*p),p,p)
  colnames(R)=colnames(X); rownames(R)=colnames(X)
  if(s1=='l') X=D(X,stas(X,1,'rng')) #s1='l': 限定距離
  if(s1=='s') X=D(X,stas(X,1,'sdp')) #s1='s': 標準距離
  for (i in 1:p){for (j in 1:i-1){
    if(s2=='e') R[i,j]=sum((X[,i]-X[,j])^2)^(1/2)   #s2='e':Euclid距離
    if(s2=='s') R[i,j]=(sum((X[,i]-X[,j])^2)/n)^(1/2)#s2='s':平均距離
    if(s2=='r') R[i,j]=sum((X[,i]-X[,j])^2)/(sum(X[,i]^2)+sum(X[,j]^2))#s2='r'; 相対距離
    R[j,i]=R[i,j]
  }}; R
} #距離行列(Distance matrix)
ddi=function(A=D){n=length(A); sum(abs(A-mean(A)))/(2*sum(A)*n/(n-1))
}#下降分布係数 (Declining distribution index)
DifM=function(X,sta='mean'){
  M=statis(X,F,sta); D=s(t(M),M) #列統計量; 縦ベクトル-横ベクトル
  colnames(D)=colnames(X); rownames(D)=colnames(X); D #表頭; 表側; 出力
} #差行列(Distance matrix)
Dummy=function(C=D){
  if(class(C)=='table') C=T2D(C)
  nr=nrow(C); nc=ncol(C); L=as.list(NULL); c=0; Cn=rep(0,nc)
  for (i in 1:nc){
    L[[i]]=sort(unique(C[,i])); c=c+length(L[[i]])
    if(i < nc){Cn[i+1]=Cn[i]+length(L[[i]])}
    if(i==1){cnames=add(colnames(C)[i],':',L[[i]])
    }else {cnames=c(cnames,add(colnames(C)[i],':',L[[i]]))}
  }; R=matrix(0,nr,c)
  for (i in 1:nr){for (j in 1:nc){
    w=which(L[[j]]==C[i,j])[1]; R[i,Cn[j]+w]=1
  }}; rownames(R)=rownames(C); colnames(R)=cnames
  W=t(R[1,])
  for (i in 2:nr){ #同じ行を合計
    if(same(R[i,],R[i-1,])){W[nrow(W),]=W[nrow(W),]+R[i,]
    }else{W=rbind(W,R[i,])}
  }
  if(nrow(W)==nrow(R)){R}else {rownames(W)=1:nrow(W); W}
} #文字行列->数値行列(ダミー行列)
#### 統計関数 (E-Q) ####
entropy=function(A=D){P=A/sum(A); -sum(P*log2(P))
} #エントロピー
entropy.r=function(A=D){P=A/sum(A); -sum(P*log2(P))/log2(length(A))
} #相対エントロピー
Exp=function(X=D){
  nr=nrow(D); nc=ncol(D); Rs=rowSums(X); Cs=colSums(X); T=sum(X)
  M=matrix(rep(0,nr*nc),nr)
  for(i in 1:length(Rs)){ for(j in 1:length(Cs)){
    M[i,j]=Rs[i]*Cs[j]/T}}; M
} #期待値
gini=function(A=D){
  s=sum(A); n=length(A); A=sort(A) #s:和; n:個数; A:昇順ソート
  q=2*sum(cumsum(A)) - s; t=n*s; 1 - q/t #q: 累積和
} #ジニ係数(A: データ配列)
gini.r=function(A=D){n=length(A); gini(A)*n/(n-1)
}#相対ジニ係数(A: データ配列)
gm=function(A=D){exp(mean(log(A)))
} #幾何平均
gmz=function(A=D){exp(mean(log(A+1)))-1
} #幾何平均(ゼロを含む)
gsd=function(A=D){exp(sdp(log(A)))
} #幾何標準偏差
gsdz=function(A=D){exp(sdp(log(A+1)))
} #幾何標準偏差(+1)
kurt=function(A=D){mean((A-mean(A))^4)/(sdp(A)^4)
} #尖度
kurt.r=function(A=D){ n=length(A); return(kurt(A) * (n-1) / (n*n - 3*n+3))
} #相対尖度 Relative Kurtosis
ldi=function(A=D){n=length(A); mx=max(A); (mx*n - sum(A)) / (mx*(n - 1))
} #L字分布係数 (L-shaped distribution index)
LS=function(X=D,s=1,d=3){
  W=apply(X,s,function(x){(x-min(x)) / (max(x)-min(x))})
  if(s==1) W=t(W); round(W,d) #横(sel==1)→転置
} #限定得点 (s=1:行； 2:列), d:小数桁数
McaEv=function(DF=D){
  nf=1; for (i in 1:ncol(DF)){nf=nf*(length(unique(DF[,i]))-1)}
  MC=mca(DF,nf); R=MC$d; E=R^2; P=E/sum(E); C=cumsum(P)
  #R:相関係数,E:固有値,P:寄与率,C:累積寄与率
  data.frame(E=round(E,3),R=round(R,3),P=perc(P),C=perc(C)) #出力
} #多重対応分析 R:相関係数,E:固有値,P:寄与率,C:累積寄与率
McaCd=function(DF=D){
  MC=mca(DF); CS=MC$cs; R=MC$d #CS: カラムスコア (2軸) R:相関係数
  round(data.frame(XR=CS[,1]*R[1],YR=CS[,2]*R[2]),3) #出力
} #多重対応分析 2軸の座標
mm=function(X=D,Y){return (MV(X,Y,'m'))} #行列・ベクトルの掛け算 X * Y
# MultLetTabs=function(E=D){
#   nc=ncol(E); C=colnames(E); if(nc==1) R=as.matrix(xtabs(~Forma,D))
#   if(nc>1) R=xtabs(~E[,C[1]]+E[,C[2]],E)
#   if(nc>2) for(i in 3:nc) R=cbind(R,xtabs(~E[,C[1]]+E[,C[i]],E)); R
# } #多次元文字データの集計
mid=function(A){(max(A)+min(A)) / 2
}#ミッドレンジ
MV=function(X,Y,sel){
  if(nrow(X)==1) X=matrix(rep(X,nrow(Y)),nrow(Y),ncol(X),byrow=T)
  if(ncol(X)==1) X=matrix(rep(X,ncol(Y)),nrow(X),ncol(Y),byrow=F)
  if(nrow(Y)==1) Y=matrix(rep(Y,nrow(X)),nrow(X),ncol(Y),byrow=T)
  if(ncol(Y)==1) Y=matrix(rep(Y,ncol(X)),nrow(Y),ncol(X),byrow=F)
  if(sel=='a') return (X+Y)
  if(sel=='s') return (X - Y)
  if(sel=='m') return (X * Y)
  if(sel=='d') return (X / Y)
} #行列・ベクトルの計算
NS=function(X,sel=1){
  W=apply(X,sel,function(X){X / sdp(as.vector(X))}) #sel=1:行； 2:列
  if(sel==1) W=t(W); W #横(sel==1)→転置
} #正規化得点 (sel=1:行； 2:列)
pareto=function(A){
  A=sort(A,decreasing=T); n=length(A); c=sum(cumsum(A))
  m=sum(cumsum(rep(mean(A),n))); s=n * sum(A); (c - m) / (s - m)
} #パレート係数 (Pareto index)
PcaEv=function(M=D,s=T){
  P=prcomp(M,scale=s) #scale=s=T: 標準化(単位が異なるとき)
  E=get_eigenvalue(P) #固有値(分散),分散%,分散累積%:library(factoextra)
  E[,1]=round(E[,1],4); E[,2]=round(E[,2],1); E[,3]=round(E[,3],1) #小数桁
  colnames(E)=c('Ev','V%','V%(cum)'); E
} #主成分分析:固有値(分散),分散%,分散累積%
perc=function(x){sprintf('%1.1f%%',x*100)
} #パーセント (0.0123 > 12.3%)
PS=function(X=D,s=1,d=3){
  if(s==2) X=t(X); Sh=apply(X,1,sum); Sv=apply(X,2,sum) #行和; 列和
  for (i in 1:length(Sh)){for (j in 1:length(Sv)){
    X[i,j]=BinE(X[i,j],Sh[i],0.99)
  }}; if(s==2) X=t(X); round(X,d)
} #確率得点 (sel=1:行； 2:列)
q1=function(A=D) {quantile(A)[2]
} #第1四分位
q2=function(A=D) {quantile(A)[3]
} #第2四分位
q3=function(A=D) {quantile(A)[4]
} #第3四分位
#### 統計関数 (R-*) ####
RankS=function(X=D,met='min',s=1,d=F){
  if(d) X=-X
  W=apply(X,s,function(X){rank(X,ties.method=met)}) #sel=1:行； 2:列
  if(s==1) W=t(W); W #横(sel==1)→転置  met:'first','min','average'
} #順位得点 (s=1:行； 2:列) d:降順
rng=function(A=D){max(A) - min(A)
} #レンジ
RS=function(X=D,s=1,d=3){ #s:列，d:小数桁
  W=apply(X,s,function(x){x / sum(x)}) #sel=1:行； 2:列
  if(s==1) W=t(W); round(W,d) #横(s)→転置; 出力
} #相対得点 (s:列)
ss=function(X,Y){return (MV(X,Y,'s'))
} #行列・ベクトルの引き算 X - Y
sdp=function(A=D) {sqrt(var(A)*(length(A)-1)/length(A))
} #標本標準偏差
skew=function(A=D){t=sum(((A - mean(A))/sd(A))^3); n=length(A); t*n/(n-1)/(n-2)
} #歪度 Excel SKEW
skew.e=function(A=D){mean((A-mean(A))^3)/(sdp(A)^3)
} #歪度 Excel SKEW.P
skew.r=function(A=D){n=length(A); skew.e(A)*sqrt(n-1)/(n-2)
} #相対歪度 relative SKEW
SS=function(X=D,sel=1){
  W=apply(X,sel,function(x){(x-mean(x)) / sdp(x)}) #sel=1:行； 2:列
  if(sel==1) W=t(W); W #横(sel==1)→転置
} #標準得点 (sel=1:行； 2:列)
Sta=function(X=D,r=F,s='sum,mean,sd',d=1){
  R=NULL; for (st in spl(s)){W=statis(X,r,st)
  if(r) R=cbind(R,W) else R=rbind(R,W)
  }
#  R
#  Round(R,d)
  round(R,d)
}#統計量: Sta(X=D,r=F,s='sum,mean,sd',d=1)
##([D],r=[F]:列/T:行,s:統計値 ex.'sum,mean,sd',d:小数桁)
#s: sum,mean,median,mid,min,max,sd,sdp,var,varp,q1,q2,q3,rng,gini,entropy
#s: gm,gmz,gsd,gsdz,kurt,kurt.r,ldi,pareto,skew,skew.e,skew.r,
statis=function(X,r,sta){
  #sta='sum',mean,median,mid,min,max,sd,sdp,var,varp,q1,q2,q3,etc.
  if(r==T){R=t(t(apply(X,1,eval(sta)))); colnames(R)=c(sta)} #行
  if(r==F){R=t(apply(X,2,eval(sta)));    rownames(R)=c(sta)} #列
  R
} #統計量 (c=1:行；2:列) sta(X,1,'mean')
std=function(d) {(d-mean(d))/sdp(d)
} #標準化
UniDis=function(A=D){
  len=length(A); M=matrix(0,len,len)
  for(i in 1:len){for(j in 1:len){M[i,j]=abs(A[i]-A[j])}};
  colnames(M)=rownames(as.matrix(A)); rownames(M)=colnames(M); M
} #一次元距離行列 unidimensional distance
xx=function(X,Y){X %*% Y
} #行列積
VV=function(X=D){as.vector(X)
} #行列=>ベクトル
varp=function(X=D){n=length(X); var(X)*(n-1)/n
} #標本分散
#### グラフ共通関数 ####
draw_colnames_0=function(coln,gaps,...){ #sheatmap(pheatmap) 回転(rot)
  #https://slowkow.com/notes/pheatmap-tutorial/
  coord=pheatmap:::find_coordinates(length(coln),gaps);x=coord$coord-0.5*coord$size
  res=textGrob(coln,x=x,y=unit(1,'npc')-unit(3,'bigpts'),
               rot=0,vjust=1,hjust=.5,gp=gpar(...));return(res) 
}
draw_colnames_90=function(coln,gaps,...){ #sheatmap(pheatmap) 回転(rot)
  #https://slowkow.com/notes/pheatmap-tutorial/
  coord=pheatmap:::find_coordinates(length(coln),gaps);x=coord$coord-0.5*coord$size
  res=textGrob(coln,x=x,y=unit(1,'npc')-unit(3,'bigpts'),
               rot=90,vjust=.5,hjust=1.1,gp=gpar(...));return(res) 
}
#assignInNamespace(x='draw_colnames',value='draw_colnames_90',ns=asNamespace('pheatmap'))
gA=function(G,a){
#  G+theme(axis.text.x=element_text(angle=a,vjust=.5,hjust=ifelse(a>0,.1,.5)))
#  G+theme(axis.text.x=element_text(angle=a,vjust=.5,hjust=ifelse(a>0,1,.5)))
  G+theme(axis.text.x=element_text(angle=a,vjust=.9,hjust=ifelse(a>0,1,.5)))
} #横軸名角度
gC=function(G,w){
  G+scale_fill_gradient(low='white',high=ifelse(w,'grey50','firebrick1'))
} #fill色：白~赤
gColorSet=function(Str,Ini,p='Set1'){
  ns=length(Str); ni=max(3,length(Ini)); R=rep('black',ns)
  P=brewer.pal(name=p,n=ni)
  for(i in 1:ns){for(j in 1:ni){
    if(str_detect(Str[i],add('^',Ini[j]))){R[i]=P[j]}}}; R #語頭一致; 出力
} #色指定 Str:対象文字配列, Ini:先頭文字配列, p:パレット
gDel=function(){
  theme(plot.title=element_text(hjust=0.5),
        axis.text.y.left=element_blank(),
        axis.ticks.y.left=element_blank(),
        axis.title.y.right=element_blank())
} #ラベル目盛消去(左目盛消去/右タイトル消去)
gDf=function(d,x,y,n,v,X,Y,t,r=F,s=F){
  if(x+y+n==0){
    if(X=='') X=Str(rownames(d)); if(Y=='') Y=Str(colnames(d));d=M2D(d)
  }
  # if(!IsD(d)){
  #   if(X=='') X=Str(rownames(d)); if(Y=='') Y=Str(colnames(d));d=M2D(d)
  # }
  x=col2n(d,x); y=col2n(d,y); n=col2n(d,n) #列名=>列番号
  if(x+y+n==0){x=1; y=2; n=3}; if(t){w=x; x=y; y=w; w=X; X=Y; Y=w} # デフォルト軸; 転置
  if(y==0){ #1軸
    d=Uniq(d,x,y,n) #ユニーク(v1,v2,n=sum)
    A=sort(t(unique(d[,1])))
    if(X==''){X=A}else {X=Fn(X,A)}
    if(v){X=rev(X)}
#    d=d%>%mutate(v1=factor(v1,levels=X)) #factorize
    d=mutate(d,v1=factor(v1,levels=X)) #factorize
  }else{ #2軸
    d=Uniq(d,x,y,n) #ユニーク(v1,v2,n=sum)
    A=sort(t(unique(d[,1]))); B=sort(t(unique(d[,2])))
    if(X==''){X=A}else {X=Fn(X,A)}
    if(Y==''){Y=B}else {Y=Fn(Y,B)}
    if(v){X=rev(X)}; if(v){Y=rev(Y)}; if(r){X=rev(X)}; if(s){Y=rev(Y)}
#    d=d%>%mutate(v1=factor(v1,levels=X),v2=factor(v2,levels=Y))} #ファクター
    d=mutate(d,v1=factor(v1,levels=X),v2=factor(v2,levels=Y))} #ファクター
return(list(d,x,y,n,X,Y))
} #データフレーム+ファクター
gEb=function() {element_blank()
} #themeのエレメントなし
gInnerScale=function(xvals, yvals, xgeo=0, ygeo=0, ticks=10){
  #https://stackoverflow.com/questions/17753101/center-x-and-y-axis-with-ggplot2
  color="gray50"; size=.5; textsize=3
  xlimit=max(abs(xvals),abs(yvals)); ylimit=max(abs(yvals),abs(xvals))
  eps=max(xlimit,ylimit)/50
  xaxis=data.frame(x_ax=c(-xlimit, xlimit),y_ax=rep(ygeo,2))
  yaxis=data.frame(x_ax=rep(xgeo, 2),y_ax=c(-ylimit, ylimit))
  R=list(theme_void(),
         geom_line(aes(x=x_ax, y=y_ax), color=color, size=size, data=xaxis),
         geom_line(aes(x=x_ax, y=y_ax), color=color, size=size, data=yaxis),
         xlim(-xlimit-7*eps, xlimit+7*eps),ylim(-ylimit-7*eps, ylimit+7*eps))
  ticks_x=round(seq(-xlimit, xlimit, length.out=ticks),2)
  ticks_y=round(seq(-ylimit, ylimit, length.out=ticks),2)
  nlist=length(R)
  for (k in 1:ticks){
    xtick=data.frame(xt=rep(ticks_x[k], 2), yt=c(xgeo+eps, xgeo-eps))
    ytick=data.frame(xt=c(ygeo+eps, ygeo-eps),yt=rep(ticks_y[k], 2))
    R[[nlist+4*k-3]]=geom_line(aes(x=xt, y=yt),data=xtick, size=size)
    R[[nlist+4*k-2]]=
      ggplot2::annotate("text", x=ticks_x[k], y=ygeo-2.5*eps, size=textsize,
                        color=color, label=paste(ticks_x[k]))
    R[[nlist+4*k-1]]=geom_line(aes(x=xt, y=yt), data=ytick, size=size)
    R[[nlist+4*k-0]]=
      ggplot2::annotate("text", x=xgeo-2.5*eps,y=ticks_y[k],
                        color=color, size=textsize,label=paste(ticks_y[k]))
  }; return(R)
} #グラフ内スケール
gF=function(G,f){G+theme(text=element_text(size=f))
} #フォントサイズ
gK=function(G,k,n,vj,f){
  if(k) G+geom_text(aes(label=n),size=f/4,vjust=vj,color='black') else G
}#数値表示
gL=function(G,lm='',lx='',ly='',lg='',f=12,c=F){
  if(lm!='') G=G+labs(title=lm)
  if(lx!='') G=G+labs(x=add(lx,'\n'))
  if(ly!='') G=G+labs(y=add(ly,'\n'))
  if(c) G=G+labs(color=add(lg,'\n')) else G=G+labs(fill=add(lg,'\n'))
  G=G+theme(axis.title=Ie(lm=='',gEb(),element_text(size=f)))
  G=G+theme(axis.title.x=Ie(lx=='',gEb(),element_text(size=f)))
  G=G+theme(axis.title.y=Ie(ly=='',gEb(),element_text(size=f)))
  G
}#ラベル (fill)
# gLc=function(G,lm,lx,ly,lg=''){
#   G+labs(title=lm,x=add(lx,'\n'),y=add(ly,'\n'),color=add(lg,'\n\n'))
# }#ラベル (color)
gLg=function(G,l,s=F){
  if(l) G=G+coord_trans(y='log1p'); if(s) G=G+coord_trans(x='log1p'); G
}#対数軸
# gLg=function(G,l){if(l){G+coord_trans(y='log1p')}else G
# }#対数軸
gP=function(G){G+theme_bw()+theme(panel.border=element_blank())
}#パネル枠消去
gPallete=function(x){
  c('Dark2','Set1','Set2','Set3','Spectral','Accent','Pastel1','Pastel2',
    'YlOrRd','GnBu','BuGn','Greys')[x]
} #色パレット (x=1,2,3...)
gPanel=function(G){
  G+theme(panel.background=gEb(),
          panel.grid.major=gEb(),panel.grid.minor=gEb(),
          panel.spacing=unit(c(0,0,0,0),"cm"),
          axis.ticks=gEb(),axis.text.x=gEb(),axis.text.y=gEb(),
          axis.title.x=gEb(),axis.title.y=gEb(),
          plot.background=element_rect(fill="transparent",colour=NA),
          plot.margin=unit(c(-1,-1.2,-1.2,-1.5),"cm"),#t,r,b,l
          legend.position='none')+labs(x=NULL,y=NULL)
}#plotのpanel部分
gPC=function(G,c,v){
  if(IsStr(c)){P=spl(c);if(v) P=rev(P)}else{P=gPallete(c)} #色パレット
  if(c==0){ #白黒
    G=G+scale_color_grey(start=ifelse(v,.2,.8),end=ifelse(v,.8,.2))
  }else if(c==1){#デフォルト色
    if(!v) G=G+scale_color_hue()
    if(v)  G=G+scale_color_hue(direction=-1,h.start=90)
  }else{#指定色/パレット
    if(IsStr(c)){G=G+scale_color_manual(values=P)  #指定色
    }else {G=G+scale_color_brewer(palette=P,direction=ifelse(v,-1,1))} #パレット
  }; G
} #パレット (color)
gPF=function(G,c,v){
  if(IsStr(c)){P=spl(c);if(v) P=rev(P)}else{P=gPallete(c)} #色パレット
  if(c==0){ #白黒
    G=G+scale_fill_grey(start=ifelse(v,.2,.8),end=ifelse(v,.8,.2))
  }else if(c==1){#デフォルト色
    if(!v) G=G+scale_fill_hue()
    if(v)  G=G+scale_fill_hue(direction=-1,h.start=90)
  }else{#指定色/パレット
    if(IsStr(c)){G=G+scale_fill_manual(values=P)  #指定色
    }else {G=G+scale_fill_brewer(palette=P,direction=ifelse(v,-1,1))} #パレット
  }; G} #パレット (fill)
gPointNum=function(N,w,c){nr=length(N); R=rep(16,nr)
if(w||c=='') for(i in 1:nr){if(substr(N[i],1,2)=='V:') R[i]=1}; R
} #gBiplot用ポイント番号
gRepColor=function(A=D,c){
  for (i in 1:length(A)){A[i]=gReplaceColor(A[i],c)}; A
} #配列Aの全要素をc='V=>blue,...'で置換(不一致はblack)
gReplaceColor=function(str,c){
  P=spl(c); rep='black'
  for (i in 1:length(P)){
    p=spl(P[i],'=>'); if(is.na(p[2])){p[2]=''}
    if(str_detect(str,add('^',p[1]))){rep=p[2]} #語頭一致
  }
  rep=ReplaceStr(rep,'^b$=>#039,^c$=>#c30,^g$=>#360,^o$=>#f60,^p$=>#c0c,^r$=>#f11') #文字変換
  rep=str_replace_all(rep,'^#(.)(.)(.)$','#\\1\\1\\2\\2\\3\\3') #ex.#123=>#112233
  rep
} #文字列strをr='p1=>r1,p2=>r2'で置換; ic=T:大小文字区別なし; ini:語頭一致
gT=function(G,X,Y){ #軸タイトル
  G+theme(line=gEb(),axis.ticks=gEb())
  if(length(X)==1) G=G+theme(axis.title.y=gEb(),axis.text.y=gEb())
  if(length(Y)==1) G=G+theme(axis.title.x=gEb(),axis.text.x=gEb()); G
}
gV=function(G,v){if(v) G+coord_flip()+guides(fill=guide_legend(reverse=T)) else G}#縦図
gZ=function(G,z,s=F){
  if(z) G=G+expand_limits(y=0); if(s) G=G+expand_limits(x=0); G
}#ゼロ開始軸
#gZ=function(G,z,s=F){if(z) G+expand_limits(y=0) else G}#ゼロ開始軸
#### グラフ個別関数 (gA-gB) ####
gArea=function(d=D,x=0,y=0,n=0,p='s',lm='',lx='',ly='',lg='',X='',Y='',a=0,f=12,c=1,l=F,z=F,k=F,v=F,t=F){
  #(d:データ,x,y,n:軸,p:配置([d]odge,[s]tack,[f]ill),lx,ly,lg:ラベル,X,Y:並べ替え
  #a:ラベル角度,f:フォントサイズ,c:パレット番号,l:対数軸,z:軸ゼロ開始,k:数値,v:縦図,t:転置
  R=gDf(d,x,y,n,v,X,Y,t); d=R[[1]]; x=R[[2]]; y=R[[3]]; n=R[[4]]; X=R[[5]]; Y=R[[6]] #データフレーム+ファクター
  p=Fn(p,c('dodge','stack','fill')) #p:ポジション
  G=ggplot(d,aes(x=v1,y=n))+geom_area(aes(group=v2,fill=v2),position=p)
  if(k&p=='stack') G=G+geom_text(aes(label=n),position=position_stack(vjust=0.5),size=f/5)#数値表示
  if(k&p=='fill')  G=G+geom_text(aes(label=n),position=position_fill(vjust=0.5),size=f/5)#数値表示
  if(p=='fill') G=G+scale_y_continuous(labels=scales::percent)
  G=gPF(G,c,v);G=gLg(G,l);G=gZ(G,z);G=gV(G,v);G=gA(G,a);G=gF(G,f);G=gL(G,lm,lx,ly,lg);G
  #P:パレット; L:対数軸; Z:ゼロ開始軸; V:縦図; A:横軸名角度; F:フォントサイズ; L:軸ラベル; G:出力
} #面グラフ

gBar=function(d=D,x=0,y=0,n=0,p='d',lm='',lx='',ly='',lg='',X='',Y='',a=0,f=12,c=1,l=F,z=F,k=F,v=F,t=F){
  #(d:データ,x,y,n:軸,p:配置([d]odge,[s]tack,[f]ill),lx,ly,lg:ラベル,X,Y:並べ替え
  #a:ラベル角度,f:フォントサイズ,c:パレット番号,l:対数軸,z:軸ゼロ開始,k:数値,v:縦図,t:転置
  R=gDf(d,x,y,n,v,X,Y,t); d=R[[1]]; x=R[[2]]; y=R[[3]]; n=R[[4]]; X=R[[5]]; Y=R[[6]] #データフレーム+ファクター
  p=Fn(p,c('dodge','stack','fill')) #p:ポジション
  if(p=='fill'){M=D2M(d); M=round(RS(M)*100,1); d=M2D(M)} #n軸パーセント
  if(y==0) G=ggplot(d,aes(x=v1,y=n)) else G=ggplot(d,aes(x=v1,y=n,group=v2,fill=v2))#1軸,2軸
  if(y==0) G=G+geom_bar(stat='identity',position=p,fill=ifelse(c==0,'gray30','steelblue')) #1軸
  if(y>0)  G=G+geom_bar(stat='identity',position=p,color='white') #geom_bar: 2軸
  if(k&p=='dodge') G=G+geom_text(aes(label=n),position=position_dodge(width=1),size=f/4,vjust=0)#数値表示
  if(k&p=='stack') G=G+geom_text(aes(label=n),position=position_stack(vjust=0.5),size=f/4)#数値表示
  if(k&p=='fill')  G=G+geom_text(aes(label=n),position=position_fill(vjust=0.5),size=f/4)#数値表示
  if(p=='fill') G=G+scale_y_continuous(labels=percent) #y軸パーセント
  G=G+theme(text=element_text(color="black"),axis.text.x=element_text(color="black"))
  G=G+theme(legend.key.height=unit(6,'mm'),legend.key.width= unit(3,'mm')) #凡例キーサイズ
  #G=G+theme(panel.background=gEb()) #背景白黒
  G=gPF(G,c,v);G=gLg(G,l);G=gZ(G,z);G=gV(G,v);G=gA(G,a);G=gF(G,f);G=gL(G,lm,lx,ly,lg);G
  #P:パレット; L:対数軸; Z:ゼロ開始軸; V:縦図; A:横軸名角度; F:フォントサイズ; L:軸ラベル; G:出力
} #棒グラフ

gBarFacet=function(d=D,x=0,y=0,n=0,lm='',lx='',ly='',X='',Y='',a=0,e=F,f=12,c=1,l=F,z=F,k=T,v=F,t=F){
  R=gDf(d,x,y,n,v,X,Y,t,r=v);d=R[[1]];x=R[[2]];y=R[[3]];n=R[[4]];X=R[[5]];Y=R[[6]] #データフレーム+ファクター
  if(c==0){G=ggplot(d,aes(x=v2,y=n))+geom_bar(stat='identity',fill='grey50')
  }else {G=ggplot(d,aes(x=v2,y=n,fill=v2))+geom_bar(stat='identity',color='white')}
  if(k) G=G+geom_text(aes(label=n),position=position_stack(vjust=0.4),size=f/5) #数値表示
  G=G+facet_wrap(~v1,ncol=1,strip.position='left')   #ファセット=>左
  G=G+theme(strip.text.y.left=element_text(angle=ifelse(e,90,0))) #ファセット角度
  G=G+theme(legend.position='none')                #凡例なし
  G=G+scale_y_continuous(sec.axis=dup_axis())+gDel() #右にY軸コピー+目盛消去
  G=gPF(G,c,v);G=gLg(G,l);G=gZ(G,z);G=gV(G,v);G=gA(G,a);G=gF(G,f);G=gL(G,lm,lx,ly,'');G
  #P:パレット; L:対数軸; Z:ゼロ開始軸; V:縦図; A:横軸名角度; F:フォントサイズ; L:軸ラベル; G:出力
} #棒グラフ(ファセット)
# (d:データ,x,y,n:軸,lx,ly:ラベル,X,Y:並べ替え
# a:ラベル角度,e:縦ファセット,f:フォントサイズ,c:パレット番号,l:対数軸,z:軸ゼロ開始,k:数値,v:縦図,t:転置

gBiplot=function(D1=V,D2=I,lm='',lx='',ly='',s=0,c='V=>blue',a=T,w=F,f=12){ #OK
  #gBiplot(D1=V,D2=I,lm='',lx='',ly='',s=0,c='',a=T,w=F,f=12,p=1)
  #D1:変数2列,D2:個体2列,lm,lx,ly:ラベル,s=[0]:変数+個体,s=1:変数,s=2:個体,
  #c:色指定(例:'V=>blue,I:i3=>red'),a:矢印,w:白黒,f:フォントサイズ,m:変数Vの乗数
  rownames(D1)=paste0('V:',rownames(D1)) #D1に'V:'を付与
  rownames(D2)=paste0('I:',rownames(D2)) #D2に'I:'を付与
  if(s==0) D=rbind(D1,D2); if(s==1) D=D1; if(s==2) D=D2
  colnames(D)=c('XR','YR'); D=as.data.frame(D); Rn=rownames(D) #D1,D2を行バインド
  if(w||c=='') {C=rep('black',nrow(D))}else {C=gRepColor(Rn,c)} #色指定
  Pn=gPointNum(Rn,w,c); L=ReplaceAr(Rn,'^..=>') #ラベル(先頭2文字削除)
  G=ggplot(D,aes(XR,YR))+geom_point(color=C,shape=Pn,size=2) #2列+点
  G=G+geom_vline(xintercept=0,lty=3); G=G+geom_hline(yintercept=0,lty=3) #基線
  if(a&s!=2) {for(i in 1:nrow(D1)){ #変数の座標に矢印線
    G=G+geom_segment(x=0,xend=D1[i,1],y=0,yend=D1[i,2],
      arrow=arrow(length=unit(.2,'cm')),color=ifelse(w,'black',C[i]))}}
  G=G+geom_text_repel(aes(label=L),size=f/3.4,color=C,min.segment.length=0) #repel
  G=G+scale_y_continuous(position='right') #右y軸
  G=gL(G,lm,lx,ly,'',f); G #gL:ラベル; G:出力
} #バイプロット

gBox=function(df=D,y=1,g=NULL,p=NULL,lm='',lx='',ly='',lg='',y1=0,y2=0,a=0,f=12,l=F,z=F,w=F){
  #df:データフレーム,y:y軸,g:グループ,p:位置(NULL,'point')
  #lx:ラベルx,ly:ラベルy,lg:ラベルg，y1:y軸下限，y2:y軸上限，
  #a:横軸名角度,f:フォントサイズ,l:対数軸,z:軸ゼロ開始w: 白黒
  y=colnam(df,y); g=colnam(df,g) #列番号->列名
  if(is.null(g)) w=T
  G=ggboxplot(df,x=g,y=y,color=ifelse(w,'black',g),
            add=ifelse(p,'point',NULL),size=.2,width=.4)+
    {if(y2 !=0) ylim(c(y1,y2))}+
    {if(w) theme_bw()}+
    labs(x=add('\n',lx),y=add(ly,'\n'),color=add(lg,'\n'))+
    theme(legend.position='right')
  G=gLg(G,l);G=gZ(G,z);G=gA(G,a);G=gF(G,f); G
  #L:対数軸; Z:ゼロ開始軸; A:横軸名角度; F:フォントサイズ; L:軸ラベル; G:出力
} #ボックスグラフ

#### グラフ個別関数 (gC-gH) ####
gChart=function(E=D,s=0,lm='',lx='',ly='',lg='',X='',Y='',a=0,b=15,f=12,k=T,t=F,w=F,d=0,c=F,gx=0,gy=0,ar=F,ac=F,m=5){
  #(E=D,s=0,lm='',lx='',ly='',lg='',X='',Y='',a=0,b=15,f=12,k=T,t=F,w=F,
  #d=0,c=F,gx=0,gy=0,ar=F,ac=F)
  #[D]:数値行列,s:チャート選択=0/'h':ヒートチャート
  #s=1/'b':バブルチャート, s=2/'bf':バブルフィルチャート,s=3/'s':スクエアチャート: s=4/'sf':スクエアフィルチャート:
  #lm,lx,ly,lg:ラベル,X,Y:並べ替え,a:X軸ラベル角度,b:バブルサイズ,f:フォントサイズ,
  #k:数値表示,t:転置,w:白黒,d:対角化=0:なし,1:行,2:列,3:行列,c:連続軸,gx.gy:グループ数(x軸,y軸),
  #ar:行軸間隔調整(d>0,c=T),ac:列軸間隔調整(d>0,c=T), m:左マージン
  if(d==0) c=F; if(a==T) a=90 #d:対角化; a:ラベル角度(x軸)
  if(s=='h') s=0; if(s=='b') s=1; if(s=='bf') s=2; if(s=='s') s=3; if(s=='sf') s=4 #s:チャート選択
  E=CorrespDg(E,d); Cns=Cn(E); Rns=Rn(E); nc=min(ncol(E),4); nr=min(nrow(E),4) #対応分析対角化
  Uc=CorrespDg(E,d,2); Hc=hclust(dist(Uc)); Cc=dendextend::cutree(Hc,1:nc) #クラスター.col
  Ur=CorrespDg(E,d,1); Hr=hclust(dist(Ur)); Cr=dendextend::cutree(Hr,1:nr); Cr=Cr[nrow(Cr):1,] #クラスター.row
  R=gDf(E,0,0,0,F,X,Y,t,r=T); E=R[[1]]; X=R[[5]]; Y=R[[6]] #データフレーム+ファクター
  cmn=min(Uc); cmx=max(Uc); cpd=(cmx-cmn)/20 #列：最小値；最大値；パディング
  rmn=min(Ur); rmx=max(Ur); rpd=(rmx-rmn)/20 #行：最小値；最大値；パディング
  # Pc=seq(cmn,cmx,length.out=length(unique(Uc))) #準備:列
  # Pr=seq(rmn,rmx,length.out=length(unique(Ur))) #準備:行
  Pc=seq(cmx,cmn,length.out=length(unique(Uc))) #準備:列
  Pr=seq(rmx,rmn,length.out=length(unique(Ur))) #準備:行
  Ur=rev(Ur); Pr=rev(Pr); Uc=rev(Uc); Pc=rev(Pc); Sr=Sc=Wr1=Wr2=Wc1=Wc2=Qr=Qc=rep(0,nrow(E))
  for(i in 1:nrow(E)){
    rn=as.numeric(E[i,1]); cn=as.numeric(E[i,2]) #行番号；列番号
    Sr[i]=Ur[rn]; Sc[i]=Uc[cn] #行スコア；列スコア
    Qr[i]=Pr[rn]; Qc[i]=Pc[cn] #行位置；列位置
    Wr1[i]=Ie(rn==length(Ur),0,abs(Ur[rn]-Ur[rn+1])) #行左幅
    Wr2[i]=Ie(rn==1,0,abs(Ur[rn]-Ur[rn-1]))          #行右幅
    Wc1[i]=Ie(cn==1,0,abs(Uc[cn]-Uc[cn-1]))          #列左幅
    Wc2[i]=Ie(cn==length(Uc),0,abs(Uc[cn]-Uc[cn+1])) #列右幅
  }
  E=transform(E,sr=Sr,sc=Sc,qr=Qr,qc=Qc,wr1=Wr1/2,wr2=Wr2/2,wc1=Wc1/2,wc2=Wc2/2) #列結合
  E[,4:11]=round(E[,4:11],3) #小数桁=3
  
  if(s==0) { #ヒートチャート
    if(!c) {#離散軸
      G=ggplot(E,aes(v2,v1))
      G=G+geom_tile(aes(fill=n),color='gray80',alpha=0.9,lwd=0.5) #離散軸 discrete axis=>タイル
      G=G+scale_fill_gradient(name=add(lg,'\n'),low='white',high=ifelse(w,'grey50','firebrick1')) #段階色
      G=gK(G,k,n,0.5,f)
    }
    if(c){ #連続軸 continuous axis
      G=ggplot(E,aes(xmin=sc-wc1,xmax=sc+wc2,ymin=sr-wr1,ymax=sr+wr2)) #ヒートチャート
      G=G+geom_rect(aes(fill=n),color='grey80',lwd=.5) #ヒートチャート
      G=G+scale_fill_gradient(name=add(lg,'\n'),low='white',high=ifelse(w,'grey50','firebrick1')) #段階色
      if(k) G=G+geom_text(aes(x=sc+(wc2-wc1)/2,y=sr+(wr2-wr1)/2,label=n),size=f/4,vjust=1,color='black') #数値
      G=G+geom_text(aes(x=sc,y=sr,label='*'),size=f/3,vjust=.5,color='black') #ポイント(*)
    }
  }
  if(s>0) { #バブルチャート (s=1:丸, s=2:四角)
    if(!c) G=ggplot(E,aes(x=v2,y=v1,size=n)) #離散軸 discrete axis
    if(c)  G=ggplot(E,aes(x=sc,y=sr,size=n)) #連続軸 continuous axis
    G=G+geom_point(alpha=.5,shape=c(1,16,0,15)[s],color=ifelse(w,'grey50','firebrick1')) #バブルの透明度,色 21丸22■
    G=G+scale_size(range=c(1,b),name=add(lg,'\n')) #バブルサイズ・名
    G=gK(G,k,n,0.5,f)
  }
  if(!c) { #離散軸
    G=G+scale_x_discrete(position='top') #上x軸
    G=G+theme(axis.text.x=element_text(hjust=0,color='black')) #X軸を左寄せ
    G=G+theme(axis.text.y=element_text(hjust=0,color='black')) #Y軸を左寄せ
    G=gK(G,k,n,0.5,f)
  }else{ #連続軸
    G=G+scale_y_continuous(position='right', breaks=round(Ur,2), sec.axis=dup_axis(name='', labels=rev(Rns)))
    G=G+scale_x_continuous(position='bottom',breaks=round(Uc,2), sec.axis=dup_axis(name='', labels=Cns))
  }
  if(d>0&gx>1) { #分離線縦:x,col
    for(i in 2:gx){for(j in 1:(nrow(Cc)-1)){
      if(Cc[j,i]!=Cc[j+1,i]) G=G+geom_vline(xintercept=Ie(c,(Uc[j]+Uc[j+1])/2,j+.5),color='gray70',size=5-i)}}}
  if(d>0&gy>1) { #分離線横:y,row
    for(i in 2:gy){for(j in 1:(nrow(Cr)-1)){ 
      if(Cr[j,i]!=Cr[j+1,i]) G=G+geom_hline(yintercept=Ie(c,(Ur[j]+Ur[j+1])/2,j+.5),color='gray70',size=5-i)}}}
  G=G+theme(axis.text.y=element_text(hjust=0)) #Y軸を左寄せ
  if(lg=='') G=G+theme(legend.position='none') #:凡例表示
  if(lx=='') G=G+theme(axis.title.x=gEb()) #x軸タイトルなし
  if(ly=='') G=G+theme(axis.title.y=gEb()) #x軸タイトルなし
  G=gA(G,a); G=gF(G,f); G=gL(G,lm,lx,ly,lg,c=T); G=gT(G,X,Y)
  #A:横軸名角度; F:フォントサイズ; L:軸ラベル; gT:軸タイトル; G:出力
  if(d>0&c&(ar|ac)){ #対角化 & 連続値 & 軸間隔調整
    coord_cartesian(xlim=c(cmn,cmx),ylim=c(rmn,rmx),clip='off') #プロットの範囲
    G=G+theme(panel.background=gEb()) #背景なし
    G=G+geom_rect(aes(xmin=cmn-cpd,xmax=cmx+cpd,ymin=rmn-rpd,ymax=rmx+rpd),fill=NA,color='grey',size=1) #四角
    G=G+geom_text (E,mapping=aes(x=cmn-cpd*m,y=Ie(ar,qr,sr),label=v1),hjust=0,size=f/4)+        #左側
      geom_segment(E,mapping=aes(x=cmn-cpd*2,y=Ie(ar,qr,sr),xend=cmn-cpd,yend=sr),size=.1,color='grey')
    G=G+geom_text (E,mapping=aes(x=cmx+cpd*2,  y=Ie(ar,qr,sr),label=sr),hjust=0,size=f/4)+      #右側
      geom_segment(E,mapping=aes(x=cmx+cpd*1.5,y=Ie(ar,qr,sr),xend=cmx+cpd,yend=sr),size=.1,color='grey')
    G=G+geom_text (E,mapping=aes(x=Ie(ac,qc,sc),y=rmx+rpd*3,label=v2),angle=a,hjust=0,size=f/4)+#上側
      geom_segment(E,mapping=aes(x=Ie(ac,qc,sc),y=rmx+rpd*2, xend=sc,yend=rmx+rpd ),size=.1,color='grey')
    G=G+geom_text (E,mapping=aes(x=Ie(ac,qc,sc),y=rmn-rpd*3,label=sc),angle=a,hjust=Ie(a==90,1,0),size=f/4)+ #下側
      geom_segment(E,mapping=aes(x=Ie(ac,qc,sc),y=rmn-rpd*2.5, xend=sc,yend=rmn-rpd),size=.1,color='grey')
    G=G+geom_segment(E,mapping=aes(x=cmn-cpd,y=sr,xend=cmx+cpd,yend=sr),size=.1,color='grey',lty=3,alpha=.5)
    G=G+geom_segment(E,mapping=aes(x=sc,y=rmx+rpd,xend=sc,yend=rmn-rpd),size=.1,color='grey',lty=3,alpha=.5)
    G=G+theme(axis.ticks=gEb(),axis.text.x=gEb(),axis.text.y=gEb()) #デフォルト軸除去
  }
  G #出力
} #チャート ver.2022-1-6

gChc=function(M=D,d=0,gx=2,gy=2,lm='',lx='',ly='',rx=0,ry=0,f=12,k=F,t=F,w=F){
  M=CorrespDg(M,d); if(t) M=t(M); X=t(M); nc=min(ncol(M),gx); nr=min(nrow(M),gy) #対応分析対角化; 転置
  Uc=CorrespCs(M); Ur=CorrespRs(M) #対応分析列/行スコア=>距離行列(dist)
  Hc=hclust(dist(Uc)); Dc=as.dendrogram(Hc); Cc=cutree(Hc,1:nc) #樹形図.col
  Hr=hclust(dist(Ur)); Dr=as.dendrogram(Hr); Cr=cutree(Hr,1:nr); Cr=Cr[nrow(Cr):1,] #樹形図.row
  if(w) Color=grey(seq(1,0.6,-0.01)) else Color=cm.colors(100) #色(w:白黒)
  G=lattice::levelplot( #Deepayan Sarkar
    X[,ncol(X):1],aspect='fill',col.regions=Color,colorkey=F,
    scales=list(x=list(rot=rx,cex=f/15),y=list(rot=ry,cex=f/15),tck=c(1,0)), 
    xlab=list(lx,cex=f/12),ylab=list(ly,cex=f/12),
    panel=function(...){panel.levelplot(...) #分離線
      if(d==0) {for (i in 2:nc){for (j in 1:(nrow(Cc)-1)){
        if(Cc[j,i]!=Cc[j+1,i]) panel.abline(v=j+.5,lwd=6-i,col='gray')}}}
      if(d==0) {for (i in 2:nr){for (j in 1:(nrow(Cr)-1)){
        if(Cr[j,i]!=Cr[j+1,i]) panel.abline(h=j+.5,lwd=6-i,col='gray')}}}})
  if(k) {M=M[nrow(M):1,]; df=M2Dn(M) #df:data frame for layer (numeric)
  G=G+layer(data=df,panel.text(v2,v1,n,cex=.5))}; G #数値表示; 出力
} #対応分析ヒートチャート Correspondent heat chart (ueda. 2021/12/07)
#gChc(M=D,d=0,gx=2,gy=2,lm='',lx='',ly='',rx=0,ry=0,f=12,k=F,t=F,w=F){
#M:数値行列=D,d:対角化(0:なし,1:行,2:列,3:行列),gx,gy:グループ数(x,y),lx,ly:ラベル(x,y),
#rx,ry;ラベル回転(x,y),f:フォントサイズ,k:数値表示,t:行列転置,w:白黒

gClusterDd=function(M=D,md='e',mc='w',s=F,t=F,g=0,lm='',lx='',ly='',v=F,f=12,m=10,w=F){
  md=Fn(md,c('canberra','euclidean','maximum','manhattan','minkowski')) #距離計測方法
  mc=Fn(mc,c('average','single','complete','ward.D2'))  #クラスタリング方法
  f=f/12; if(t) M=t(M); if(s) M=SS(M,2) #転置; 正規化(列)
  d=as.dendrogram(hclust(dist(M,md),method=mc)) #データ
  if(v) Mg=c(4,5,0,m)else Mg=c(m,5,0,2) #下・右マージン
  labels_cex(d)=f; par(cex.axis=f*.8,cex.lab=f*1.2,mar=Mg) #cex, mar
  if(g<2|w==T) {plot(d,ylab=ly,horiz=v) #樹形図(グループなし|白黒)
  }else {plot(color_branches(d,k=g),xlab='',ylab=ly,horiz=v)} #樹形図
  if(v) x=2 else x=m-1 #縦X軸のときはライン数(x)=2, そうでなければm(マージン)-1
  title(xlab=lx,line=x,cex.lab=f*1.2) #X軸ラベル
  if(g>1) rect.dendrogram(d,k=g,horiz=v,lty=5,border='gray') #分割直方体(灰色点線)
} #クラスター樹形図 (cluster dendrogram)border = 8, lty = 5, lwd = 2
#gClusterDd(M=D,md='e',mc='w',s=F,t=F,g=0,lm='',lx='',ly='',v=F,f=12,m=10,w=F)
#M:数値行列,s:正規化(列),t:転置,g:グループ数,lm,lx,ly:ラベル,v:X軸縦,f:文字サイズ,m:マージン幅,w:白黒
#md:距離計測方法('[c]anberra','[e]uclidean','[max]imum','[man]hattan','[mi]nkowski')
#mc:クラスタリング方法('[a]verage','[s]ingle','[c]omplete','[w]ard.D2')

gCorrespBp=function(M=D,lm='',lx='',ly='',s=0,c='V=>blue',a=T,w=F,f=12,m=1){
  M=as.matrix(M)
  CA=corresp(M,min(nrow(M),ncol(M))); R=CA$cor #CA:対応分析(MASS); R:相関係数
  # V=data.frame(XR=CA$cscore[,1]*R[1],YR=CA$cscore[,2]*R[2])*m
  # I=data.frame(XR=CA$rscore[,1]*R[1],YR=CA$rscore[,2]*R[2])#行
  
  S=CorrespSc(M,1); V=data.frame(XR=S[,1]*R[1],YR=S[,2]*R[2])*m #列スコア
  S=CorrespSc(M,0); I=data.frame(XR=S[,1]*R[1],YR=S[,2]*R[2])   #行スコア

  R=CA$cor; E=R^2; P=E*100/sum(E) #R:相関係数,E:固有値,P:寄与率
  
  if(lx=='') lx=add('\nCorresp. Biplot: Dim.1 (',round(P[1],1),' %)') #1軸ラベル(デフォルト)
  if(ly=='') ly=add('Dim.2 (',round(P[2],1),' %)') #2軸ラベル(デフォルト)
  gBiplot(V,I,lm,lx,ly,s,c,a,w,f) #バイプロット
} #対応分析バイプロット
#gCorrespBp(M=D,lm='',lx='',ly='',s=0,c='',a=T,w=F,f=12,m=1)
#M:数値行列,lm,lx,ly:ラベル,s=[0]:変数+個体/s=1:変数/s=2:個体,
#c:色指定(例:'V=>blue,..'),a:矢印,w:白黒,m:変数Vの乗数

gCpc=function(M=D,d=0,lm='',lx='',ly='',rx=0,ry=0,f=12,k=F,t=F,w=F){
  M=CorrespDg(M,d); if(t) M=t(M); X=t(M); nc=min(ncol(M),4); nr=min(nrow(M),4) #対応分析対角化; 転置
  Uc=CorrespCs(M); Ur=CorrespRs(M) #対応分析列/行スコア=>距離行列(dist)
  Hc=hclust(dist(Uc)); Dc=as.dendrogram(Hc); Cc=cutree(Hc,1:nc) #樹形図.col
  Hr=hclust(dist(Ur)); Dr=as.dendrogram(Hr); Cr=cutree(Hr,1:nr); Cr=Cr[nrow(Cr):1,] #樹形図.row
  if(w) Color=grey(seq(1,0.6,-0.01)) else Color=cm.colors(100) #色(w:白黒)
  G=lattice::levelplot( #Deepayan Sarkar
    X[,ncol(X):1],aspect='fill',col.regions=Color,colorkey=F,
    scales=list(x=list(rot=rx,cex=f/15),y=list(rot=ry,cex=f/15)), 
    xlab=list(lx,cex=f/12),ylab=list(ly,cex=f/12),
    panel=function(...){panel.levelplot(...) #分離線
      if(d==0) {for(j in 1:(nrow(Cc)-1)){
        if(Cc[j,2]!=Cc[j+1,2]) panel.abline(v=j+.5,lty=3)}}
      if(d==0) {for(j in 1:(nrow(Cr)-1)){
        if(Cr[j,2]!=Cr[j+1,2]) panel.abline(h=j+.5,lty=3)}}},
    legend=list(
      right=list(fun=dendrogramGrob(x=Dr,side='right',size=2)),
      top=  list(fun=dendrogramGrob(x=Dc,side='top',  size=2))))
  if(k) {M=M[nrow(M):1,]; df=M2Dn(M) #df:data frame for layer (numeric)
  G=G+layer(data=df,panel.text(v2,v1,n,cex=.5))}; G #数値表示; 出力
} #対応パタンクラスター Correspondent pattern cluster (ueda, 2019)
#gCpc(M=D,d=0,lm='',lx='',ly='',rx=0,ry=0,f=12,k=F,t=F,w=F){
#M:数値行列=D,d:対角化(0:なし,1:行,2:列,3:行列),lm,lx,ly:ラベル(x,y),
#rx,ry;ラベル回転(x,y),f:フォントサイズ,k:数値表示,t:行列転置,w:白黒

gHeatDd=function(M=D,d=F,r=4,c=4,s=F,gr=2,gc=2,lm='',lx='',ly='',l=F,v=F,f=12,k=F,t=F,w=F,dn=0){
  #Oren Ben-Kiki: https://tanaylab.github.io/slanter/reference/sheatmap.html
  #ｇHeatDd(M=D,md='e',mc='w',d=F,r=4,c=4,s=F,gr=2,gc=2,lm='',lx='',ly='',l=F,v=F,f=12,k=F,t=F,w=F)
  #M:数値行列=D,md(*),mc(*),d:対角化,r:樹形図の高さ(行)(0:なし),c:樹形図の高さ(行)(0:なし)
  #s:正規化(列),gr:行グループ数=2,gc:列グループ数=2
  #lm,lx,ly:ラベル,l:凡例表示,v;縦X軸ラベル,f:フォントサイズ,k:数値表示,t:行列転置,w:白黒,dn:小数桁
  #md(*):距離計測方法('[c]anberra','[e]uclidean','[max]imum','[man]hattan','[mi]nkowski')
  #mc(*):クラスタリング方法('[a]verage','[s]ingle','[c]omplete','[w]ard.D2')
  if(t) M=t(M); if(s) M=SS(M,2) #転置; 正規化(列)
  if(w) Color=grey(seq(1,0.6,-0.01)) else Color=cm.colors(100) #タイル色(w:白黒)
  if(v) {dcn='draw_colnames_90'}else {dcn='draw_colnames_0'} #縦X軸ラベル
  if(gr==0) gr=1; if(gc==0) gc=1 #グループなし
  assignInNamespace(x='draw_colnames',value=dcn,ns=asNamespace('pheatmap')) # '
  clr=ifelse(r>0,T,F); clc=ifelse(c>0,T,F) #cluster_rows, cluster_cols #樹形図表示
  nf=paste0('%.',as.character(dn),'f') #number format
  setHook('grid.newpage',function() #XYラベル用
    pushViewport(viewport(x=1,y=1,width=0.9,height=0.9,name='vp',just=c('right','top'))))
  slanter::sheatmap(M,color=Color,display_numbers=k, #cf.pheatmap
                    order_rows=d,cluster_rows=clr,oclust_rows=F,cutree_rows=gr,
                    order_cols=d,cluster_cols=clc,oclust_cols=F,cutree_cols=gc,
                    fontsize_number=f*.8,fontsize_row=f,fontsize_col=f,
                    treeheight_row=r*10,treeheight_col=c*10,legend=l,number_format=nf)
  setHook('grid.newpage', NULL, 'replace') #XYラベル用
  grid.text(lx,gp=gpar(fontsize=f),y=ifelse(v,-.08,0)) #'
  grid.text(ly,gp=gpar(fontsize=f),x=-.05,rot=90) #'
} #クラスターヒートチャート (sheatmap)

gHist=function(df=D,x=1,g=0,p='d',lm='',lx='',ly='',lg='',c=1,b=10,f=12,l=F,z=F,k=F,v=F){
  df=ff(df); x=colnam(df,x); if(g==0) g=NULL; g=colnam(df,g) #列番号->列名
  if(lx=='') lx=x; if(ly=='') lx='N'; if(lg=='') lg=g
  p=ReplaceStr(p,c('d.*=>dodge','s.*=>stack','f.*=>fill')) #p:ポジション
  G=ggplot(df,aes_string(x,fill=g),alpha=1)
  if(is.null(g)){G=G+geom_histogram(bins=b,color='white',fill=ifelse(c==0,'gray30','steelblue'))
  }else {G=G+geom_histogram(bins=b,color='white',position=p)}
  if(k&v)  G=G+stat_bin(position=p,aes(label=..count..),geom='text',bins=b,hjust=-0,size=3) #数値
  if(k&!v) G=G+stat_bin(position=p,aes(label=..count..),geom='text',bins=b,vjust=0,size=3)
  if(z) G=G+expand_limits(x=0) #x軸ゼロ開始
  if(p=='fill') G=G+scale_y_continuous(labels=percent) #y軸パーセント
  G=gPF(G,c,v);G=gLg(G,l);G=gV(G,v);G=gF(G,f);G=gL(G,lm,lx,ly,lg);G
  #L:対数軸; V:縦図;; F:フォントサイズ; L:軸ラベル; G:出力
} #ヒストグラフ
#df,x:x軸列,g:グループ列,p:[d]odge,[s]tack,[f]ill),lm,lx,ly:ラベル(x,y)，
#c:パレット,b:棒数,z:0を含むx軸,f:フォントサイズ,l:対数軸,z:x軸ゼロ開始,k:数値出力,v:縦図
#### グラフ個別関数 (gL-g*) ####
gLine=function(d=D,x=0,y=0,n=0,lm='',lx='',ly='',lg='',X='',Y='',u=0,a=0,f=12,c=1,l=F,z=F,k=F,v=F,t=F,sl=T){
  #gLine(d=D,x=0,y=0,n=0,lm='',lx='',ly='',lg='',X='',Y='',u=0,a=0,f=12,c=1,l=F,z=F,k=F,v=F,t=F,sl=T)
  #(d:データ,x,y,n:軸,lm,lx,ly,lg:ラベル,X,Y:並べ替え,u:線結合ラベル(0:なし,1:左,2:右,3:左右)
  #a:ラベル角度,f:フォントサイズ,c:パレット番号,l:対数軸,z:軸ゼロ開始,k:数値,v:縦図,t:転置,sl:凡例出力
  R=gDf(d,x,y,n,v,X,Y,t,s=v); d=R[[1]]; x=R[[2]]; y=R[[3]]; n=R[[4]]; X=R[[5]]; Y=R[[6]] #データフレーム+ファクター
  if(y==0){G=ggplot(d,aes(x=v1,y=n)) #1軸
  }else {if(c==0) G=ggplot(d,aes(x=v1,y=n,group=v2))
  if(c>0)  G=ggplot(d,aes(x=v1,y=n,group=v2,color=v2))} #1軸,2軸
  if(c==0) G=G+geom_line(aes(linetype=v2),show.legend=sl)
  if(c>0)  G=G+geom_line(size=0.8,show.legend=sl)
  # if(u==1|u==3) G=G+geom_text_repel(data=d%>%filter(v1==X[1]),#線左端ラベル
  #                                   aes(x=v1,y=n,label=v2),nudge_x=-1,segment.alpha=0.5,size=4,direction='y')
  # if(u==2|u==3) G=G+geom_text_repel(data=d%>%filter(v1==X[length(X)]),#線右端ラベル
  #                                   aes(x=v1,y=n,label=v2),nudge_x=1,segment.alpha=0.5,size=4,direction='y')
  if(u==1|u==3) G=G+geom_text_repel(data=filter(d,v1==X[1]),#線左端ラベル
    aes(x=v1,y=n,label=v2),nudge_x=-1,segment.alpha=0.5,size=4,direction='y',min.segment.length=0)
  if(u==2|u==3) G=G+geom_text_repel(data=filter(d,v1==X[length(X)]),#線右端ラベル
    aes(x=v1,y=n,label=v2),nudge_x=1,segment.alpha=0.5,size=4,direction='y',min.segment.length=0)
  G=G+geom_point(size=2.5,show.legend=sl); G=gK(G,k,n,-0.5,f); G=gPC(G,c,v)#点; 数値表示; パレット
  G=G+theme(text=element_text(color="black"), axis.text.x=element_text(color="black"))
  G=gLg(G,l); G=gZ(G,z); G=gV(G,v); G=gA(G,a); G=gF(G,f); G=gL(G,lm,lx,ly,lg,c=T); G
  #L:対数軸; Z:ゼロ開始軸; V:縦図; A:横軸名角度; F:フォントサイズ; L:軸ラベル; G:出力
} #線グラフ

gPcaBp=function(M=D,lm='',lx='',ly='',s=0,c='V=>blue',a=T,w=F,st=T,f=12,m=1){
  P=prcomp(M,scale=st) #scale=s=T: 標準化(単位が異なるとき)
  E=get_eigenvalue(P) #固有値(分散),分散%,分散累積%:library(factoextra)
  if(lx=='') lx=add('PCA biplot: Dim.1 (',round(E[1,2],1),' %)') #1軸ラベル(デフォルト)
  if(ly=='') ly=add('Dim.2 (',round(E[2,2],1),' %)') #2軸ラベル(デフォルト)
  V=P$rotation[,1:2]*m; I=P$x[,1:2] #固有ベクトル; 主成分スコア
  gBiplot(V,I,lm,lx,ly,s,c,a,w,f) #バイプロット
} #主成分分析:バイプロット
#gPcaBp(M=D,lm='',lm='',lx='',ly='',s=0,c='',a=T,w=F,f=12,m=1)
#M:数値行列,lm,lx,ly:ラベル,s=[0]:変数+個体/s=1:変数/s=2:個体,
#c:色指定(例:'V=>blue,..'),a:矢印,w:白黒,m:変数Vの乗数

gPcaGp=function(M=D,gr=G,lg='',c='',s=T){
  P=prcomp(M,scale=s) #scale=s=T: 標準化(単位が異なるとき)
  groups=as.factor(gr); if(c=='') c='tomato,steelblue'
  fviz_pca_ind(P,col.ind=groups,palette=spl(c),#グループの色
               addEllipses=T,ellipse.type='confidence',#信頼楕円
               legend.title=lg,repel=T,title='')
} #主成分分析(グループ)

gPoint=function(E=D,x=1,y=2,g=0,lm='',lx='',ly='',lg='',r=F,s=1,w=F,f=12,
                Lx=F,Ly=F,z=F,a=0,p='vh',d='both'){ #ver.2022-1-7
  #E:,x:x軸,y:y軸,g:グループ軸,lm,lx,ly,lg:ラベル,r:行名,s:ポイントサイズ,
  #w: 白黒,f:フォントサイズ,Lx:対数軸(x),Ly:対数軸(y),z:両軸ゼロ開始,a:行名角度,
  #p:配置('vh':平面,'v':縦図,'h':横図,d:行名の移動方向('both','x','y')
  E=ff(E); x=col2n(E,x); y=col2n(E,y); g=col2n(E,g) #列名=>列番号
  if(lx==''&x>0) lx=colnames(E)[x] #デフォルトラベル:X軸
  if(ly==''&y>0) ly=colnames(E)[y] #デフォルトラベル:Y軸
  if(lg==''&g>0) lg=colnames(E)[g] #デフォルトラベル:凡例
  if(x>0) colnames(E)[x]='vx'; if(y>0) colnames(E)[y]='vy'; if(g>0) colnames(E)[g]='vg' #列名
  wd=10; pt=wd/10; nd=wd*.3; if (!r) pt=wd/2 #wd:グラフの幅;pt点の位置;nd:行名の位置
  if(p=='vh') G=ggplot(E,aes(vx,vy,label=rownames(E)))  #平面図
  if(p=='v')  G=ggplot(E,aes(pt,vx,label=rownames(E)))      #縦図
  if(p=='h')  G=ggplot(E,aes(vx,pt,label=rownames(E)))      #横図
  if(g==0){ #グループ化なし
    G=G+geom_point(shape=16,size=s,color=Ie(w,'black','red')) #カラー/白黒
  }else {   #グループ化あり
    G=G+geom_point(aes(shape=vg,color=Ie(w,NULL,vg)),size=s) #白黒
    n=length(unique(E[,g])); G=G+scale_shape_manual(name=lg, values=1:n) #ポイントの形
    if(!w) G=G+scale_color_manual(name=lg, values=cls(n))                 #ポイントの色
  }
  if(r){options(ggrepel.max.overlaps=Inf) #行名
    if(p=='vh') { #平面図
      G=G+geom_text_repel(min.segment.length=0,segment.color='gray40',size=f/4,
                          direction=d,angle=a)}
    if(p=='v'){ #縦図
      G=G+geom_text_repel(min.segment.length=0,segment.color='gray40',size=f/4,
                          direction='y',angle=0,nudge_x=nd,hjust=0)}
    if(p=='h'){ #横図
      G=G+geom_text_repel(min.segment.length=0,segment.color='gray40',size=f/4,
                          direction='x',angle=90,nudge_y=nd,hjust=0)}
  }
  if(p=='v') G=G+theme(axis.ticks.x=gEb(),axis.text.x=gEb())+xlim(0,wd) #X軸クリア;範囲.縦図
  if(p=='h') G=G+theme(axis.ticks.y=gEb(),axis.text.y=gEb())+ylim(0,wd) #Y軸クリア;範囲.横図
  G=gLg(G,Ly,Lx); G=gZ(G,z,z); G=gF(G,f); G=gL(G,lm,lx,ly,lg,f,T); G
  #L:対数軸; Z:ゼロ開始軸;F:フォントサイズ; L:軸ラベル; G:出力
} #ポイント散布図

gSave=function(p=G,f='@.jpg',w=30,h=20,d=600){
  ggsave(plot=p,filename=f,width=w,height=h,units='cm',dpi=d)
} #グラフ保存
#gSave(p=G,f='x.jpg',w=30,h=20,d=600)
#p:グラフオブジェクト,f:ファイル名,w:幅(cm),h:高さ(cm),d:dpi



