#P.R パッケージ 2021/11/05

source('S.R'); Start() #開始

rm(list=ls()) #全部消去 Remove all

par(mar=c(2,2,2,2)) #余白の大きさを下，左，上，右の順に行の高さ(mex)で指定
dev.off() #デバイスを閉じる (初期値に戻る)

load(".RData") #ワークスペースを復元
save.image(".RData") #ワークスペースを保存
getwd() #Get working directory # 作業用ディレクトリ (working directory)

#setwd("D:/R/R-ueda") #Set working directory

#すべて折りたたみ: (Win) Alt+O       (Mac) Ctrl+Command+O
#すべて展開: 　　　(Win) Alt+Shift+O (Mac) Ctrl+Command+Shift+O

#スペイン語文字・日本語(MAC)を扱う
Sys.setlocale(category = 'LC_CTYPE', locale = 'spanish')#スペイン語文字
par(family = "HiraKakuProN-W3") #日本語(MAC)

############ パッケージをインストール (一度だけ)
# install.packages("RColorBrewer")
# install.packages("data.table")
# install.packages("epitools")  #epitools
# install.packages("factoextra") #PCA
# install.packages("ggnewscale")#ggnewscale (scale_fill)
# install.packages('gplots')   #
# install.packages('ggtext')   #
# install.packages("maptools")  #pointLabel
# install.packages("mosaid")    #ggnewscale
# install.packages("patchwork") #p1 + p2出力
# install.packages("ggrepel") #文字列のプロットを重ねない
# install.packages('showtext')   #
# install.packages("textplot") ##不要？
# install.packages("vcd") #mosaic
# install.packages("wesanderson")
# install.packages('ggpubr')    #ggdensity etc.
# install.packages('stringr')   #文字列処理
# install.packages('tidyverse') #ggplot2
# install.packages('vegan')   #
# font_add_google("Lato")
# showtext_auto()

install.packages('vcd') #mosaic

install.packages("ggmosaic")
library(ggmosaic)
install.packages('dendextend') #slanter::sheatmap
library('dendextend')
install.packages('colorspace') #slanter::sheatmap
library('colorspace')
install.packages('slanter') #slanter::sheatmap
library('slanter')
library(grid)
#install.packages('ComplexHeatmap')
#library(ComplexHeatmap)
install.packages('pheatmap')
library('pheatmap')
install.packages('lattice')
library('lattice')
library(latticeExtra)
install.packages("magrittr")
library(magrittr)

library(data.table)
library(dplyr)
library(epitools)
library(factoextra) #PCA
library(ggmosaic)
library(ggnewscale)
library(ggplot2) #
library(gplots)
library(ggpubr)
library(ggtext)
library(showtext)
library(MASS)
library(maptools)
library(ggrepel)
library(mosaic)
library(patchwork)
library(pheatmap)
library(RColorBrewer)
library(reshape2)
library(rlang)
library(scales)
library(stringr)
library(slanter)
library(textplot)##不要？
library(tidyr)
library(tidyverse)
library(tm)
library(viridis)
library(vcd)
library(wordcloud)
library(vegan)
library(showtext)
# font_add_google("Lato")
# showtext_auto()
#source('DF.R'); source('SF.R');source('GF.R')

#install.packages("prettyR")
#library(prettyR) xxx 不要


#関数ファイルを読み込む
#source('DF.R'); source('SF.R');source('GF.R')

#日本語文字
#https://www.karada-good.net/analyticsr/r-58
#familyを設定することで文字化けが防止できます
par(family = "HiraKakuProN-W3") #日本語(MAC)
TestData <- data.frame("ラベル" = c("あ", "い", "う", "え", "お"), "出現数" = rep(1, 5))
plot <- ggplot(TestData, aes(x = TestData[, 1]))
plot + geom_bar() +theme_bw(base_family = "")


###
setHook(packageEvent("grDevices", "onLoad"),
        function(...){
          if(.Platform$OS.type == "windows")
            grDevices::windowsFonts(sans ="MS Gothic",
                                    serif="MS Mincho",
                                    mono ="FixedFont")
          if(capabilities("aqua"))
            grDevices::quartzFonts(
              sans =grDevices::quartzFont(
                c("Hiragino Kaku Gothic Pro W3",
                  "Hiragino Kaku Gothic Pro W6",
                  "Hiragino Kaku Gothic Pro W3",
                  "Hiragino Kaku Gothic Pro W6")),
              serif=grDevices::quartzFont(
                c("Hiragino Mincho Pro W3",
                  "Hiragino Mincho Pro W6",
                  "Hiragino Mincho Pro W3",
                  "Hiragino Mincho Pro W6")))
          if(capabilities("X11"))
            grDevices::X11.options(
              fonts=c("-kochi-gothic-%s-%s-*-*-%d-*-*-*-*-*-*-*",
                      "-adobe-symbol-medium-r-*-*-%d-*-*-*-*-*-*-*"))
          grDevices::pdf.options(family="Japan1GothicBBB")
          grDevices::ps.options(family="Japan1GothicBBB")
        }
)
attach(NULL, name = "JapanEnv")
assign("familyset_hook",
       function() {
         winfontdevs=c("windows","win.metafile",
                       "png","bmp","jpeg","tiff","RStudioGD")
         macfontdevs=c("quartz","quartz_off_screen","RStudioGD")
         devname=strsplit(names(dev.cur()),":")[[1L]][1]
         if ((.Platform$OS.type == "windows") &&
             (devname %in% winfontdevs))
           par(family="sans")
         if (capabilities("aqua") &&
             devname %in% macfontdevs)
           par(family="sans")
       },
       pos="JapanEnv")
setHook("plot.new", get("familyset_hook", pos="JapanEnv"))
setHook("persp", get("familyset_hook", pos="JapanEnv"))
