## S.R: 初期設定ファイル ##

Start=function(){ #開始/初期化
#  load(".RData") #ワークスペースを復元
  rm(list=ls()) #全部消去 Remove all
  library(MASS)
  library(RColorBrewer)
  library(colorspace)
  library(data.table)
  library(dendextend)
  library(dplyr)
  library(epitools)
  library(factoextra) #PCA
  library(ggdendro)
  library(ggmosaic)
  library(ggnewscale)
  library(ggplot2) #
  library(ggpubr)
  library(ggrepel)
  library(ggtext)
  library(gplots)
  library(grid)
  library(lattice)
  library(latticeExtra)
  library(magrittr)
  library(maptools)
  library(mosaic)
  library(patchwork)
  library(pheatmap)
  library(reshape2)
  library(rlang)
  library(scales)
  library(showtext)
  library(slanter)
  library(stringr)
  library(textplot)##不要？
  library(tidyr)
  library(tidyverse)
  library(tm)
  library(vcd)
  library(vegan)
  library(viridis)
  library(wordcloud)
#  Sys.setlocale(category = 'LC_CTYPE', locale = 'spanish')#スペイン語文字
  par(family = "HiraKakuProN-W3") #日本語文字(MAC)
  dev.off() #デバイスを閉じる (初期値に戻る)
  source('F.R') #関数ファイル
}
# Sys.setlocale(category = 'LC_CTYPE', locale = 'spanish')#スペイン語文字
# Sys.setlocale("LC_ALL", 'Japanese_Japan.932')
# 
# extrafont::loadfonts(device = "win")
# names(windowsFonts())
# 
# install.packages("extrafont")
# 
# library(extrafont)
# font_import()
# loadfonts(device = "win")
# 
# windowsFonts(Times=windowsFont("TT Times New Roman"))
# 
# theme_minimal(base_family = "HiraKakuProN-W3") #MAC


# Plotting
extrafont::loadfonts(device="pdf")
extrafont::loadfonts(device="postscript")
# extrafont::font_import("C:/Windows/Fonts/", pattern = "RobotoCondensed", prompt = F)
# extrafont::fonttable()
# C:/Program Files/R/R-3.3.1/library/extrafontdb/fontmap/ - Change lights to "Roboto Condensed Light"
# After ggsave(device="pdf") or ggsave(device="eps") open and resave the file in Illustrator

###
setHook(packageEvent("grDevices", "onLoad"),
        function(...){
          if(.Platform$OS.type == "windows")
            grDevices::windowsFonts(sans ="MS Gothic",
                                    serif="MS Mincho",
                                    mono ="FixedFont")
          if(capabilities("aqua"))
            grDevices::quartzFonts(
              sans =grDevices::quartzFont(
                c("Hiragino Kaku Gothic Pro W3",
                  "Hiragino Kaku Gothic Pro W6",
                  "Hiragino Kaku Gothic Pro W3",
                  "Hiragino Kaku Gothic Pro W6")),
              serif=grDevices::quartzFont(
                c("Hiragino Mincho Pro W3",
                  "Hiragino Mincho Pro W6",
                  "Hiragino Mincho Pro W3",
                  "Hiragino Mincho Pro W6")))
          if(capabilities("X11"))
            grDevices::X11.options(
              fonts=c("-kochi-gothic-%s-%s-*-*-%d-*-*-*-*-*-*-*",
                      "-adobe-symbol-medium-r-*-*-%d-*-*-*-*-*-*-*"))
          grDevices::pdf.options(family="Japan1GothicBBB")
          grDevices::ps.options(family="Japan1GothicBBB")
        }
)
attach(NULL, name = "JapanEnv")
assign("familyset_hook",
       function() {
         winfontdevs=c("windows","win.metafile",
                       "png","bmp","jpeg","tiff","RStudioGD")
         macfontdevs=c("quartz","quartz_off_screen","RStudioGD")
         devname=strsplit(names(dev.cur()),":")[[1L]][1]
         if ((.Platform$OS.type == "windows") &&
             (devname %in% winfontdevs))
           par(family="sans")
         if (capabilities("aqua") &&
             devname %in% macfontdevs)
           par(family="sans")
       },
       pos="JapanEnv")
setHook("plot.new", get("familyset_hook", pos="JapanEnv"))
setHook("persp", get("familyset_hook", pos="JapanEnv"))
